
Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Module CMQB
    '**********************************************************************'
    '*                                                                    *'
    '*                  IBM MQSeries for Windows NT and Windows 2000      *'
    '*                                                                    *'
    '*  MODULE NAME:    CMQB                                              *'
    '*                                                                    *'
    '*  DESCRIPTION:    Declarations for Main MQI                         *'
    '*                                                                    *'
    '**********************************************************************'
    '*  @START_COPYRIGHT@                                                 *'
    '*  Licensed Materials - Property of IBM                              *'
    '*                                                                    *'
    '*  0784726, 5639-B43  MQSeries for Windows NT and Windows 2000       *'
    '*                                                                    *'
    '*  (C) Copyright IBM Corporation 1994, 2000.                         *'
    '*                                                                    *'
    '*  Status: Version 5 Release 2                                       *'
    '*  @END_COPYRIGHT@                                                   *'
    '**********************************************************************'
    '*                                                                    *'
    '*  FUNCTION:       This file declares the functions, structures,     *'
    '*                  and named constants for the main MQI.             *'
    '*                                                                    *'
    '*  PROCESSOR:      BASIC                                             *'
    '*                                                                    *'
    '**********************************************************************'

    '**********************************************************************'
    '*  This file is for use with the following products:                 *'
    '*                                                                    *'
    '*  o   Windows Visual Basic Version 5.0 (32-bit)                     *'
    '*  o   Windows Visual Basic Version 6.0 (32-bit)                     *'
    '*                                                                    *'
    '*  This file can be used with either the MQSeries server or the      *'
    '*  MQSeries client, depending on the conditional compilation         *'
    '*  argument MqType:                                                  *'
    '*                                                                    *'
    '*  o   To set MqType:                                                *'
    '*                                                                    *'
    '*      1.  Select the menu option "Project - xx Properties" (where   *'
    '*          xx is the name of the project).                           *'
    '*      2.  On the tab labelled "Make", edit the field "Conditional   *'
    '*          Compilation".                                             *'
    '*                                                                    *'
    '*  o   In the "Conditional Compiliation" field, enter (without the   *'
    '*      quotes):                                                      *'
    '*                                                                    *'
    '*          "MqType = 1" for the MQSeries server                      *'
    '*          "MqType = 2" for the MQSeries client                      *'
    '*                                                                    *'
    '*  The selection of client/server controls the selection of          *'
    '*  MQSeries DLL. The appropriate DLL must be installed and the       *'
    '*  queue manager running for the Visual Basic application to         *'
    '*  operate correctly.                                                *'
    '*                                                                    *'
    '*  To ensure that various default constants are setup properly, the  *'
    '*  procedure MQ_SETDEFAULTS should be called before any other        *'
    '*  MQSeries calls. A good place to put this call is in the Load      *'
    '*  procedure of the startup form. See the sample programs for an     *'
    '*  example.                                                          *'
    '*                                                                    *'
    '*  COMMON PROBLEMS:                                                  *'
    '*                                                                    *'
    '*  ================================================                  *'
    '*  Visual Basic error:                                               *'
    '*  o   Run-time error '48': Error in loading DLL                     *'
    '*  o   Run-time error '53': File not found                           *'
    '*  ================================================                  *'
    '*  PROBLEM:                                                          *'
    '*  o   Incorrect Mqtype setting                                      *'
    '*  SOLUTION:                                                         *'
    '*  o   Change MqType setting -- see comments above                   *'
    '*                                                                    *'
    '*  ================================================                  *'
    '*  Run-time error: CompCode = 2, Reason = 2059                       *'
    '*  ================================================                  *'
    '*  PROBLEM:                                                          *'
    '*  o   MQRC_Q_MGR_NOT_AVAILABLE: Queue Manager not available         *'
    '*  SOLUTION:                                                         *'
    '*  o   Check MQSERVER environment variable:                          *'
    '*        Under Windows NT/2000                                       *'
    '*          Click: Start->Settings->Control Panel                     *'
    '*          Double Click: System                                      *'
    '*          Click tab for ENVIRONMENT                                 *'
    '*          Add/Change System variable:                               *'
    '*            MQSERVER=channel_name/tcp/tcp_name                      *'
    '*        Under Windows 95/98                                         *'
    '*          Edit AUTOEXEC.BAT file                                    *'
    '*          Add the line:                                             *'
    '*          SET MQSERVER=channel_name/tcp/tcp_name                    *'
    '*        Note: channel_name is case sensitive                        *'
    '*  o   For Windows 95/98 Check:                                      *'
    '*        \MQM\MQS.INI has an entry:                                  *'
    '*          AllQueueManagers:                                         *'
    '*            DefaultPrefix=D:\mqm                                    *'
    '*            D: is disk where MQClient is installed                  *'
    '*        If necessary, rerun REGISTER.EXE from D:\MQM directory      *'
    '*        The above MQS.INI is not relevant for NT/2000.              *'
    '*  o   Verify that the server can be pinged:                         *'
    '*        ping tcp_name                                               *'
    '*  o   Verify C samples work:                                        *'
    '*        \MQM\TOOLS\SAMPLES\C\BIN\AMQSPUTC.EXE                       *'
    '*        \MQM\TOOLS\SAMPLES\C\BIN\AMQSGETC.EXE                       *'
    '*                                                                    *'
    '**********************************************************************'

    '**********************************************************************'
    '*  Values Related to MQBO Structure                                  *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQBO_STRUC_ID As String = "BO  "

    'Structure Version Number'
    Public Const MQBO_VERSION_1 As Short = 1
    Public Const MQBO_CURRENT_VERSION As Short = 1

    'Begin Options'
    Public Const MQBO_NONE As Short = 0


    '**********************************************************************'
    '*  Values Related to MQCIH Structure                                 *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQCIH_STRUC_ID As String = "CIH "

    'Structure Version Number'
    Public Const MQCIH_VERSION_1 As Short = 1
    Public Const MQCIH_VERSION_2 As Short = 2
    Public Const MQCIH_CURRENT_VERSION As Short = 2

    'Structure Length'
    Public Const MQCIH_LENGTH_1 As Short = 164
    Public Const MQCIH_LENGTH_2 As Short = 180
    Public Const MQCIH_CURRENT_LENGTH As Short = 180

    'Flags'
    Public Const MQCIH_NONE As Short = 0

    'Return Code'
    Public Const MQCRC_OK As Short = 0
    Public Const MQCRC_CICS_EXEC_ERROR As Short = 1
    Public Const MQCRC_MQ_API_ERROR As Short = 2
    Public Const MQCRC_BRIDGE_ERROR As Short = 3
    Public Const MQCRC_BRIDGE_ABEND As Short = 4
    Public Const MQCRC_APPLICATION_ABEND As Short = 5
    Public Const MQCRC_SECURITY_ERROR As Short = 6
    Public Const MQCRC_PROGRAM_NOT_AVAILABLE As Short = 7
    Public Const MQCRC_BRIDGE_TIMEOUT As Short = 8
    Public Const MQCRC_TRANSID_NOT_AVAILABLE As Short = 9

    'Unit of Work Control'
    Public Const MQCUOWC_ONLY As Short = 273
    Public Const MQCUOWC_CONTINUE As Integer = 65536
    Public Const MQCUOWC_FIRST As Short = 17
    Public Const MQCUOWC_MIDDLE As Short = 16
    Public Const MQCUOWC_LAST As Short = 272
    Public Const MQCUOWC_COMMIT As Short = 256
    Public Const MQCUOWC_BACKOUT As Short = 4352

    'Get Wait Interval'
    Public Const MQCGWI_DEFAULT As Short = -2

    'Link Type'
    Public Const MQCLT_PROGRAM As Short = 1
    Public Const MQCLT_TRANSACTION As Short = 2

    'Output Data Length'
    Public Const MQCODL_AS_INPUT As Short = -1

    'ADS Descriptor'
    Public Const MQCADSD_NONE As Short = 0
    Public Const MQCADSD_SEND As Short = 1
    Public Const MQCADSD_RECV As Short = 16
    Public Const MQCADSD_MSGFORMAT As Short = 256

    'Conversational Task'
    Public Const MQCCT_YES As Short = 1
    Public Const MQCCT_NO As Short = 0

    'Task End Status'
    Public Const MQCTES_NOSYNC As Short = 0
    Public Const MQCTES_COMMIT As Short = 256
    Public Const MQCTES_BACKOUT As Short = 4352
    Public Const MQCTES_ENDTASK As Integer = 65536

    'Facility'
    'Call MQ_SETDEFAULTS subroutine to initialize the following'
    Public MQCFAC_NONE As New VB6.FixedLengthString(8)

    'Function'
    Public Const MQCFUNC_MQCONN As String = "CONN"
    Public Const MQCFUNC_MQGET As String = "GET "
    Public Const MQCFUNC_MQINQ As String = "INQ "
    Public Const MQCFUNC_MQOPEN As String = "OPEN"
    Public Const MQCFUNC_MQPUT As String = "PUT "
    Public Const MQCFUNC_MQPUT1 As String = "PUT1"
    Public Const MQCFUNC_NONE As String = "    "

    'Start Code'
    Public Const MQCSC_START As String = "S   "
    Public Const MQCSC_STARTDATA As String = "SD  "
    Public Const MQCSC_TERMINPUT As String = "TD  "
    Public Const MQCSC_NONE As String = "    "


    '**********************************************************************'
    '*  Values Related to MQCNO Structure                                 *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQCNO_STRUC_ID As String = "CNO "

    'Structure Version Number'
    Public Const MQCNO_VERSION_1 As Short = 1
    Public Const MQCNO_VERSION_2 As Short = 2
    Public Const MQCNO_CURRENT_VERSION As Short = 2

    'Connect Options'
    Public Const MQCNO_STANDARD_BINDING As Short = 0
    Public Const MQCNO_FASTPATH_BINDING As Short = 1
    Public Const MQCNO_NONE As Short = 0


    '**********************************************************************'
    '*  Values Related to MQDH Structure                                  *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQDH_STRUC_ID As String = "DH  "

    'Structure Version Number'
    Public Const MQDH_VERSION_1 As Short = 1
    Public Const MQDH_CURRENT_VERSION As Short = 1

    'General Flags'
    Public Const MQDHF_NEW_MSG_IDS As Short = 1
    Public Const MQDHF_NONE As Short = 0

    'Put Message Record Flags'
    'See values for "Put Message Record Fields" under MQPMO'


    '**********************************************************************'
    '*  Values Related to MQDLH Structure                                 *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQDLH_STRUC_ID As String = "DLH "

    'Structure Version Number'
    Public Const MQDLH_VERSION_1 As Short = 1
    Public Const MQDLH_CURRENT_VERSION As Short = 1


    '**********************************************************************'
    '*  Values Related to MQGMO Structure                                 *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQGMO_STRUC_ID As String = "GMO "

    'Structure Version Number'
    Public Const MQGMO_VERSION_1 As Short = 1
    Public Const MQGMO_VERSION_2 As Short = 2
    Public Const MQGMO_VERSION_3 As Short = 3
    Public Const MQGMO_CURRENT_VERSION As Short = 3

    'Get-Message Options'
    Public Const MQGMO_WAIT As Short = 1
    Public Const MQGMO_NO_WAIT As Short = 0
    Public Const MQGMO_SET_SIGNAL As Short = 8
    Public Const MQGMO_FAIL_IF_QUIESCING As Short = 8192
    Public Const MQGMO_SYNCPOINT As Short = 2
    Public Const MQGMO_SYNCPOINT_IF_PERSISTENT As Short = 4096
    Public Const MQGMO_NO_SYNCPOINT As Short = 4
    Public Const MQGMO_MARK_SKIP_BACKOUT As Short = 128
    Public Const MQGMO_BROWSE_FIRST As Short = 16
    Public Const MQGMO_BROWSE_NEXT As Short = 32
    Public Const MQGMO_BROWSE_MSG_UNDER_CURSOR As Short = 2048
    Public Const MQGMO_MSG_UNDER_CURSOR As Short = 256
    Public Const MQGMO_LOCK As Short = 512
    Public Const MQGMO_UNLOCK As Short = 1024
    Public Const MQGMO_ACCEPT_TRUNCATED_MSG As Short = 64
    Public Const MQGMO_CONVERT As Short = 16384
    Public Const MQGMO_LOGICAL_ORDER As Integer = 32768
    Public Const MQGMO_COMPLETE_MSG As Integer = 65536
    Public Const MQGMO_ALL_MSGS_AVAILABLE As Integer = 131072
    Public Const MQGMO_ALL_SEGMENTS_AVAILABLE As Integer = 262144
    Public Const MQGMO_NONE As Short = 0

    'Wait Interval'
    Public Const MQWI_UNLIMITED As Short = -1

    'Signal Values'
    Public Const MQEC_MSG_ARRIVED As Short = 2
    Public Const MQEC_WAIT_INTERVAL_EXPIRED As Short = 3
    Public Const MQEC_WAIT_CANCELED As Short = 4
    Public Const MQEC_Q_MGR_QUIESCING As Short = 5
    Public Const MQEC_CONNECTION_QUIESCING As Short = 6

    'Match Options'
    Public Const MQMO_MATCH_MSG_ID As Short = 1
    Public Const MQMO_MATCH_CORREL_ID As Short = 2
    Public Const MQMO_MATCH_GROUP_ID As Short = 4
    Public Const MQMO_MATCH_MSG_SEQ_NUMBER As Short = 8
    Public Const MQMO_MATCH_OFFSET As Short = 16
    Public Const MQMO_MATCH_MSG_TOKEN As Short = 32
    Public Const MQMO_NONE As Short = 0

    'Group Status'
    Public Const MQGS_NOT_IN_GROUP As String = " "
    Public Const MQGS_MSG_IN_GROUP As String = "G"
    Public Const MQGS_LAST_MSG_IN_GROUP As String = "L"

    'Segment Status'
    Public Const MQSS_NOT_A_SEGMENT As String = " "
    Public Const MQSS_SEGMENT As String = "S"
    Public Const MQSS_LAST_SEGMENT As String = "L"

    'Segmentation'
    Public Const MQSEG_INHIBITED As String = " "
    Public Const MQSEG_ALLOWED As String = "A"

    'Message Token'
    'Call MQ_SETDEFAULTS subroutine to initialize the following'
    Public MQMTOK_NONE As New VB6.FixedLengthString(16)

    'Returned Length'
    Public Const MQRL_UNDEFINED As Short = -1


    '**********************************************************************'
    '*  Values Related to MQIIH Structure                                 *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQIIH_STRUC_ID As String = "IIH "

    'Structure Version Number'
    Public Const MQIIH_VERSION_1 As Short = 1
    Public Const MQIIH_CURRENT_VERSION As Short = 1

    'Structure Length'
    Public Const MQIIH_LENGTH_1 As Short = 84

    'Flags'
    Public Const MQIIH_NONE As Short = 0

    'Authenticator'
    Public Const MQIAUT_NONE As String = "        "

    'Transaction Instance Identifier'
    'Call MQ_SETDEFAULTS subroutine to initialize the following'
    Public MQITII_NONE As New VB6.FixedLengthString(16)

    'Transaction State'
    Public Const MQITS_IN_CONVERSATION As String = "C"
    Public Const MQITS_NOT_IN_CONVERSATION As String = " "
    Public Const MQITS_ARCHITECTED As String = "A"

    'Commit Mode'
    Public Const MQICM_COMMIT_THEN_SEND As String = "0"
    Public Const MQICM_SEND_THEN_COMMIT As String = "1"

    'Security Scope'
    Public Const MQISS_CHECK As String = "C"
    Public Const MQISS_FULL As String = "F"


    '**********************************************************************'
    '*  Values Related to MQMD Structure                                  *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQMD_STRUC_ID As String = "MD  "

    'Structure Version Number'
    Public Const MQMD_VERSION_1 As Short = 1
    Public Const MQMD_VERSION_2 As Short = 2
    Public Const MQMD_CURRENT_VERSION As Short = 2

    'Report Options'
    Public Const MQRO_EXCEPTION As Integer = 16777216
    Public Const MQRO_EXCEPTION_WITH_DATA As Integer = 50331648
    Public Const MQRO_EXCEPTION_WITH_FULL_DATA As Integer = 117440512
    Public Const MQRO_EXPIRATION As Integer = 2097152
    Public Const MQRO_EXPIRATION_WITH_DATA As Integer = 6291456
    Public Const MQRO_EXPIRATION_WITH_FULL_DATA As Integer = 14680064
    Public Const MQRO_COA As Short = 256
    Public Const MQRO_COA_WITH_DATA As Short = 768
    Public Const MQRO_COA_WITH_FULL_DATA As Short = 1792
    Public Const MQRO_COD As Short = 2048
    Public Const MQRO_COD_WITH_DATA As Short = 6144
    Public Const MQRO_COD_WITH_FULL_DATA As Short = 14336
    Public Const MQRO_PAN As Short = 1
    Public Const MQRO_NAN As Short = 2
    Public Const MQRO_NEW_MSG_ID As Short = 0
    Public Const MQRO_PASS_MSG_ID As Short = 128
    Public Const MQRO_COPY_MSG_ID_TO_CORREL_ID As Short = 0
    Public Const MQRO_PASS_CORREL_ID As Short = 64
    Public Const MQRO_DEAD_LETTER_Q As Short = 0
    Public Const MQRO_DISCARD_MSG As Integer = 134217728
    Public Const MQRO_NONE As Short = 0

    'Report Options Masks'
    Public Const MQRO_REJECT_UNSUP_MASK As Integer = &H101C0000
    Public Const MQRO_ACCEPT_UNSUP_MASK As Integer = &HEFE000FF
    Public Const MQRO_ACCEPT_UNSUP_IF_XMIT_MASK As Integer = &H3FF00

    'Message Types'
    Public Const MQMT_SYSTEM_FIRST As Short = 1
    Public Const MQMT_REQUEST As Short = 1
    Public Const MQMT_REPLY As Short = 2
    Public Const MQMT_DATAGRAM As Short = 8
    Public Const MQMT_REPORT As Short = 4
    Public Const MQMT_MQE_FIELDS_FROM_MQE As Short = 112
    Public Const MQMT_MQE_FIELDS As Short = 113
    Public Const MQMT_SYSTEM_LAST As Integer = 65535
    Public Const MQMT_APPL_FIRST As Integer = 65536
    Public Const MQMT_APPL_LAST As Integer = 999999999

    'Expiry'
    Public Const MQEI_UNLIMITED As Short = -1

    'Feedback Values'
    Public Const MQFB_NONE As Short = 0
    Public Const MQFB_SYSTEM_FIRST As Short = 1
    Public Const MQFB_QUIT As Short = 256
    Public Const MQFB_EXPIRATION As Short = 258
    Public Const MQFB_COA As Short = 259
    Public Const MQFB_COD As Short = 260
    Public Const MQFB_CHANNEL_COMPLETED As Short = 262
    Public Const MQFB_CHANNEL_FAIL_RETRY As Short = 263
    Public Const MQFB_CHANNEL_FAIL As Short = 264
    Public Const MQFB_APPL_CANNOT_BE_STARTED As Short = 265
    Public Const MQFB_TM_ERROR As Short = 266
    Public Const MQFB_APPL_TYPE_ERROR As Short = 267
    Public Const MQFB_STOPPED_BY_MSG_EXIT As Short = 268
    Public Const MQFB_XMIT_Q_MSG_ERROR As Short = 271
    Public Const MQFB_PAN As Short = 275
    Public Const MQFB_NAN As Short = 276
    Public Const MQFB_STOPPED_BY_CHAD_EXIT As Short = 277
    Public Const MQFB_STOPPED_BY_PUBSUB_EXIT As Short = 279
    Public Const MQFB_NOT_A_REPOSITORY_MSG As Short = 280
    Public Const MQFB_BIND_OPEN_CLUSRCVR_DEL As Short = 281
    Public Const MQFB_DATA_LENGTH_ZERO As Short = 291
    Public Const MQFB_DATA_LENGTH_NEGATIVE As Short = 292
    Public Const MQFB_DATA_LENGTH_TOO_BIG As Short = 293
    Public Const MQFB_BUFFER_OVERFLOW As Short = 294
    Public Const MQFB_LENGTH_OFF_BY_ONE As Short = 295
    Public Const MQFB_IIH_ERROR As Short = 296
    Public Const MQFB_NOT_AUTHORIZED_FOR_IMS As Short = 298
    Public Const MQFB_IMS_ERROR As Short = 300
    Public Const MQFB_IMS_FIRST As Short = 301
    Public Const MQFB_IMS_LAST As Short = 399
    Public Const MQFB_CICS_INTERNAL_ERROR As Short = 401
    Public Const MQFB_CICS_NOT_AUTHORIZED As Short = 402
    Public Const MQFB_CICS_BRIDGE_FAILURE As Short = 403
    Public Const MQFB_CICS_CORREL_ID_ERROR As Short = 404
    Public Const MQFB_CICS_CCSID_ERROR As Short = 405
    Public Const MQFB_CICS_ENCODING_ERROR As Short = 406
    Public Const MQFB_CICS_CIH_ERROR As Short = 407
    Public Const MQFB_CICS_UOW_ERROR As Short = 408
    Public Const MQFB_CICS_COMMAREA_ERROR As Short = 409
    Public Const MQFB_CICS_APPL_NOT_STARTED As Short = 410
    Public Const MQFB_CICS_APPL_ABENDED As Short = 411
    Public Const MQFB_CICS_DLQ_ERROR As Short = 412
    Public Const MQFB_CICS_UOW_BACKED_OUT As Short = 413
    Public Const MQFB_SYSTEM_LAST As Integer = 65535
    Public Const MQFB_APPL_FIRST As Integer = 65536
    Public Const MQFB_APPL_LAST As Integer = 999999999

    'Encoding'
    Public Const MQENC_NATIVE As Short = 546

    'Encoding Masks'
    Public Const MQENC_INTEGER_MASK As Integer = &HF
    Public Const MQENC_DECIMAL_MASK As Integer = &HF0
    Public Const MQENC_FLOAT_MASK As Integer = &HF00
    Public Const MQENC_RESERVED_MASK As Integer = &HFFFFF000

    'Encodings for Binary Integers'
    Public Const MQENC_INTEGER_UNDEFINED As Short = 0
    Public Const MQENC_INTEGER_NORMAL As Short = 1
    Public Const MQENC_INTEGER_REVERSED As Short = 2

    'Encodings for Packed-Decimal Integers'
    Public Const MQENC_DECIMAL_UNDEFINED As Short = 0
    Public Const MQENC_DECIMAL_NORMAL As Short = 16
    Public Const MQENC_DECIMAL_REVERSED As Short = 32

    'Encodings for Floating-Point Numbers'
    Public Const MQENC_FLOAT_UNDEFINED As Short = 0
    Public Const MQENC_FLOAT_IEEE_NORMAL As Short = 256
    Public Const MQENC_FLOAT_IEEE_REVERSED As Short = 512
    Public Const MQENC_FLOAT_S390 As Short = 768

    'Coded Character-Set Identifiers'
    Public Const MQCCSI_UNDEFINED As Short = 0
    Public Const MQCCSI_DEFAULT As Short = 0
    Public Const MQCCSI_Q_MGR As Short = 0
    Public Const MQCCSI_INHERIT As Short = -2
    Public Const MQCCSI_EMBEDDED As Short = -1

    'Formats'
    Public Const MQFMT_NONE As String = "        "
    Public Const MQFMT_ADMIN As String = "MQADMIN "
    Public Const MQFMT_CHANNEL_COMPLETED As String = "MQCHCOM "
    Public Const MQFMT_CICS As String = "MQCICS  "
    Public Const MQFMT_COMMAND_1 As String = "MQCMD1  "
    Public Const MQFMT_COMMAND_2 As String = "MQCMD2  "
    Public Const MQFMT_DEAD_LETTER_HEADER As String = "MQDEAD  "
    Public Const MQFMT_DIST_HEADER As String = "MQHDIST "
    Public Const MQFMT_EVENT As String = "MQEVENT "
    Public Const MQFMT_IMS As String = "MQIMS   "
    Public Const MQFMT_IMS_VAR_STRING As String = "MQIMSVS "
    Public Const MQFMT_MD_EXTENSION As String = "MQHMDE  "
    Public Const MQFMT_PCF As String = "MQPCF   "
    Public Const MQFMT_REF_MSG_HEADER As String = "MQHREF  "
    Public Const MQFMT_RF_HEADER As String = "MQHRF   "
    Public Const MQFMT_RF_HEADER_2 As String = "MQHRF2  "
    Public Const MQFMT_STRING As String = "MQSTR   "
    Public Const MQFMT_TRIGGER As String = "MQTRIG  "
    Public Const MQFMT_WORK_INFO_HEADER As String = "MQHWIH  "
    Public Const MQFMT_XMIT_Q_HEADER As String = "MQXMIT  "

    'Priority'
    Public Const MQPRI_PRIORITY_AS_Q_DEF As Short = -1

    'Persistence Values'
    Public Const MQPER_NOT_PERSISTENT As Short = 0
    Public Const MQPER_PERSISTENT As Short = 1
    Public Const MQPER_PERSISTENCE_AS_Q_DEF As Short = 2

    'Message Identifier'
    'Call MQ_SETDEFAULTS subroutine to initialize the following'
    Public MQMI_NONE As New VB6.FixedLengthString(24)

    'Correlation Identifier'
    'Call MQ_SETDEFAULTS subroutine to initialize the following'
    Public MQCI_NONE As New VB6.FixedLengthString(24)
    Public MQCI_NEW_SESSION As New VB6.FixedLengthString(24)

    'Accounting Token'
    'Call MQ_SETDEFAULTS subroutine to initialize the following'
    Public MQACT_NONE As New VB6.FixedLengthString(32)

    'Accounting Token Type'
    'Call MQ_SETDEFAULTS subroutine to initialize the following'
    Public MQACTT_UNKNOWN As New VB6.FixedLengthString(1)
    Public MQACTT_CICS_LUOW_ID As New VB6.FixedLengthString(1)
    Public MQACTT_OS2_DEFAULT As New VB6.FixedLengthString(1)
    Public MQACTT_DOS_DEFAULT As New VB6.FixedLengthString(1)
    Public MQACTT_UNIX_NUMERIC_ID As New VB6.FixedLengthString(1)
    Public MQACTT_OS400_ACCOUNT_TOKEN As New VB6.FixedLengthString(1)
    Public MQACTT_WINDOWS_DEFAULT As New VB6.FixedLengthString(1)
    Public MQACTT_NT_SECURITY_ID As New VB6.FixedLengthString(1)
    Public MQACTT_USER As New VB6.FixedLengthString(1)

    'Put Application Types'
    Public Const MQAT_UNKNOWN As Short = -1
    Public Const MQAT_NO_CONTEXT As Short = 0
    Public Const MQAT_CICS As Short = 1
    Public Const MQAT_MVS As Short = 2
    Public Const MQAT_OS390 As Short = 2
    Public Const MQAT_IMS As Short = 3
    Public Const MQAT_OS2 As Short = 4
    Public Const MQAT_DOS As Short = 5
    Public Const MQAT_AIX As Short = 6
    Public Const MQAT_UNIX As Short = 6
    Public Const MQAT_QMGR As Short = 7
    Public Const MQAT_OS400 As Short = 8
    Public Const MQAT_WINDOWS As Short = 9
    Public Const MQAT_CICS_VSE As Short = 10
    Public Const MQAT_WINDOWS_NT As Short = 11
    Public Const MQAT_VMS As Short = 12
    Public Const MQAT_GUARDIAN As Short = 13
    Public Const MQAT_NSK As Short = 13
    Public Const MQAT_VOS As Short = 14
    Public Const MQAT_IMS_BRIDGE As Short = 19
    Public Const MQAT_XCF As Short = 20
    Public Const MQAT_CICS_BRIDGE As Short = 21
    Public Const MQAT_NOTES_AGENT As Short = 22
    Public Const MQAT_BROKER As Short = 26
    Public Const MQAT_JAVA As Short = 28
    Public Const MQAT_DQM As Short = 29
    Public Const MQAT_DEFAULT As Short = 11
    Public Const MQAT_USER_FIRST As Integer = 65536
    Public Const MQAT_USER_LAST As Integer = 999999999

    'Group Identifier'
    'Call MQ_SETDEFAULTS subroutine to initialize the following'
    Public MQGI_NONE As New VB6.FixedLengthString(24)

    'Message Flags'
    Public Const MQMF_SEGMENTATION_INHIBITED As Short = 0
    Public Const MQMF_SEGMENTATION_ALLOWED As Short = 1
    Public Const MQMF_MSG_IN_GROUP As Short = 8
    Public Const MQMF_LAST_MSG_IN_GROUP As Short = 16
    Public Const MQMF_SEGMENT As Short = 2
    Public Const MQMF_LAST_SEGMENT As Short = 4
    Public Const MQMF_NONE As Short = 0

    'Message Flags Masks'
    Public Const MQMF_REJECT_UNSUP_MASK As Integer = &HFFF
    Public Const MQMF_ACCEPT_UNSUP_MASK As Integer = &HFFF00000
    Public Const MQMF_ACCEPT_UNSUP_IF_XMIT_MASK As Integer = &HFF000

    'Original Length'
    Public Const MQOL_UNDEFINED As Short = -1


    '**********************************************************************'
    '*  Values Related to MQMDE Structure                                 *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQMDE_STRUC_ID As String = "MDE "

    'Structure Version Number'
    Public Const MQMDE_VERSION_2 As Short = 2
    Public Const MQMDE_CURRENT_VERSION As Short = 2

    'Structure Length'
    Public Const MQMDE_LENGTH_2 As Short = 72

    'General Flags'
    Public Const MQMDEF_NONE As Short = 0


    '**********************************************************************'
    '*  Values Related to MQOD Structure                                  *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQOD_STRUC_ID As String = "OD  "

    'Structure Version Number'
    Public Const MQOD_VERSION_1 As Short = 1
    Public Const MQOD_VERSION_2 As Short = 2
    Public Const MQOD_VERSION_3 As Short = 3
    Public Const MQOD_CURRENT_VERSION As Short = 3

    'Structure Length'
    Public Const MQOD_CURRENT_LENGTH As Short = 336

    'Object Types'
    Public Const MQOT_Q As Short = 1
    Public Const MQOT_NAMELIST As Short = 2
    Public Const MQOT_PROCESS As Short = 3
    Public Const MQOT_Q_MGR As Short = 5
    Public Const MQOT_CHANNEL As Short = 6
    Public Const MQOT_RESERVED_1 As Short = 7

    'Extended Object Types'
    Public Const MQOT_ALL As Short = 1001
    Public Const MQOT_ALIAS_Q As Short = 1002
    Public Const MQOT_MODEL_Q As Short = 1003
    Public Const MQOT_LOCAL_Q As Short = 1004
    Public Const MQOT_REMOTE_Q As Short = 1005
    Public Const MQOT_SENDER_CHANNEL As Short = 1007
    Public Const MQOT_SERVER_CHANNEL As Short = 1008
    Public Const MQOT_REQUESTER_CHANNEL As Short = 1009
    Public Const MQOT_RECEIVER_CHANNEL As Short = 1010
    Public Const MQOT_CURRENT_CHANNEL As Short = 1011
    Public Const MQOT_SAVED_CHANNEL As Short = 1012
    Public Const MQOT_SVRCONN_CHANNEL As Short = 1013
    Public Const MQOT_CLNTCONN_CHANNEL As Short = 1014

    'Security Identifier'
    'Call MQ_SETDEFAULTS subroutine to initialize the following'
    Public MQSID_NONE As New VB6.FixedLengthString(40)

    'Security Identifier Type'
    'Call MQ_SETDEFAULTS subroutine to initialize the following'
    Public MQSIDT_NONE As New VB6.FixedLengthString(1)
    Public MQSIDT_NT_SECURITY_ID As New VB6.FixedLengthString(1)


    '**********************************************************************'
    '*  Values Related to MQPMO Structure                                 *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQPMO_STRUC_ID As String = "PMO "

    'Structure Version Number'
    Public Const MQPMO_VERSION_1 As Short = 1
    Public Const MQPMO_VERSION_2 As Short = 2
    Public Const MQPMO_CURRENT_VERSION As Short = 2

    'Structure Length'
    Public Const MQPMO_CURRENT_LENGTH As Short = 152

    'Put-Message Options'
    Public Const MQPMO_SYNCPOINT As Short = 2
    Public Const MQPMO_NO_SYNCPOINT As Short = 4
    Public Const MQPMO_NEW_MSG_ID As Short = 64
    Public Const MQPMO_NEW_CORREL_ID As Short = 128
    Public Const MQPMO_LOGICAL_ORDER As Integer = 32768
    Public Const MQPMO_NO_CONTEXT As Short = 16384
    Public Const MQPMO_DEFAULT_CONTEXT As Short = 32
    Public Const MQPMO_PASS_IDENTITY_CONTEXT As Short = 256
    Public Const MQPMO_PASS_ALL_CONTEXT As Short = 512
    Public Const MQPMO_SET_IDENTITY_CONTEXT As Short = 1024
    Public Const MQPMO_SET_ALL_CONTEXT As Short = 2048
    Public Const MQPMO_ALTERNATE_USER_AUTHORITY As Short = 4096
    Public Const MQPMO_FAIL_IF_QUIESCING As Short = 8192
    Public Const MQPMO_NONE As Short = 0

    'Put Message Record Fields'
    Public Const MQPMRF_MSG_ID As Short = 1
    Public Const MQPMRF_CORREL_ID As Short = 2
    Public Const MQPMRF_GROUP_ID As Short = 4
    Public Const MQPMRF_FEEDBACK As Short = 8
    Public Const MQPMRF_ACCOUNTING_TOKEN As Short = 16
    Public Const MQPMRF_NONE As Short = 0


    '**********************************************************************'
    '*  Values Related to MQRFH Structure                                 *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQRFH_STRUC_ID As String = "RFH "

    'Structure Version Number'
    Public Const MQRFH_VERSION_1 As Short = 1
    Public Const MQRFH_VERSION_2 As Short = 2

    'Structure Length'
    Public Const MQRFH_STRUC_LENGTH_FIXED As Short = 32
    Public Const MQRFH_STRUC_LENGTH_FIXED_2 As Short = 36

    'Flags'
    Public Const MQRFH_NONE As Short = 0

    'Names for Name/Value String'
    Public Const MQNVS_APPL_TYPE As String = "OPT_APP_GRP "
    Public Const MQNVS_MSG_TYPE As String = "OPT_MSG_TYPE "


    '**********************************************************************'
    '*  Values Related to MQRMH Structure                                 *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQRMH_STRUC_ID As String = "RMH "

    'Structure Version Number'
    Public Const MQRMH_VERSION_1 As Short = 1
    Public Const MQRMH_CURRENT_VERSION As Short = 1

    'Flags'
    Public Const MQRMHF_LAST As Short = 1
    Public Const MQRMHF_NOT_LAST As Short = 0

    'Object Instance Identifier'
    'Call MQ_SETDEFAULTS subroutine to initialize the following'
    Public MQOII_NONE As New VB6.FixedLengthString(24)


    '**********************************************************************'
    '*  Values Related to MQTM Structure                                  *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQTM_STRUC_ID As String = "TM  "

    'Structure Version Number'
    Public Const MQTM_VERSION_1 As Short = 1
    Public Const MQTM_CURRENT_VERSION As Short = 1


    '**********************************************************************'
    '*  Values Related to MQTMC2 Structure                                *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQTMC_STRUC_ID As String = "TMC "

    'Structure Version Number'
    Public Const MQTMC_VERSION_1 As String = "   1"
    Public Const MQTMC_VERSION_2 As String = "   2"
    Public Const MQTMC_CURRENT_VERSION As String = "   2"


    '**********************************************************************'
    '*  Values Related to MQWIH Structure                                 *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQWIH_STRUC_ID As String = "WIH "

    'Structure Version Number'
    Public Const MQWIH_VERSION_1 As Short = 1
    Public Const MQWIH_CURRENT_VERSION As Short = 1

    'Structure Length'
    Public Const MQWIH_LENGTH_1 As Short = 120
    Public Const MQWIH_CURRENT_LENGTH As Short = 120

    'Flags'
    Public Const MQWIH_NONE As Short = 0


    '**********************************************************************'
    '*  Values Related to MQXQH Structure                                 *'
    '**********************************************************************'

    'Structure Identifier'
    Public Const MQXQH_STRUC_ID As String = "XQH "

    'Structure Version Number'
    Public Const MQXQH_VERSION_1 As Short = 1
    Public Const MQXQH_CURRENT_VERSION As Short = 1


    '**********************************************************************'
    '*  Values Related to MQCLOSE Function                                *'
    '**********************************************************************'

    'Object Handle'
    Public Const MQHO_UNUSABLE_HOBJ As Short = -1
    Public Const MQHO_NONE As Short = 0

    'Close Options'
    Public Const MQCO_NONE As Short = 0
    Public Const MQCO_DELETE As Short = 1
    Public Const MQCO_DELETE_PURGE As Short = 2


    '**********************************************************************'
    '*  Values Related to MQINQ Function                                  *'
    '**********************************************************************'

    'Character-Attribute Selectors'
    Public Const MQCA_ALTERATION_DATE As Short = 2027
    Public Const MQCA_ALTERATION_TIME As Short = 2028
    Public Const MQCA_APPL_ID As Short = 2001
    Public Const MQCA_BACKOUT_REQ_Q_NAME As Short = 2019
    Public Const MQCA_BASE_Q_NAME As Short = 2002
    Public Const MQCA_CF_STRUC_NAME As Short = 2039
    Public Const MQCA_CHANNEL_AUTO_DEF_EXIT As Short = 2026
    Public Const MQCA_CLUSTER_DATE As Short = 2037
    Public Const MQCA_CLUSTER_NAME As Short = 2029
    Public Const MQCA_CLUSTER_NAMELIST As Short = 2030
    Public Const MQCA_CLUSTER_Q_MGR_NAME As Short = 2031
    Public Const MQCA_CLUSTER_TIME As Short = 2038
    Public Const MQCA_CLUSTER_WORKLOAD_DATA As Short = 2034
    Public Const MQCA_CLUSTER_WORKLOAD_EXIT As Short = 2033
    Public Const MQCA_COMMAND_INPUT_Q_NAME As Short = 2003
    Public Const MQCA_CREATION_DATE As Short = 2004
    Public Const MQCA_CREATION_TIME As Short = 2005
    Public Const MQCA_DEAD_LETTER_Q_NAME As Short = 2006
    Public Const MQCA_DEF_XMIT_Q_NAME As Short = 2025
    Public Const MQCA_ENV_DATA As Short = 2007
    Public Const MQCA_FIRST As Short = 2001
    Public Const MQCA_IGQ_USER_ID As Short = 2041
    Public Const MQCA_INITIATION_Q_NAME As Short = 2008
    Public Const MQCA_LAST As Short = 4000
    Public Const MQCA_LAST_USED As Short = 2041
    Public Const MQCA_NAMELIST_DESC As Short = 2009
    Public Const MQCA_NAMELIST_NAME As Short = 2010
    Public Const MQCA_NAMES As Short = 2020
    Public Const MQCA_PROCESS_DESC As Short = 2011
    Public Const MQCA_PROCESS_NAME As Short = 2012
    Public Const MQCA_Q_DESC As Short = 2013
    Public Const MQCA_Q_MGR_DESC As Short = 2014
    Public Const MQCA_Q_MGR_IDENTIFIER As Short = 2032
    Public Const MQCA_Q_MGR_NAME As Short = 2015
    Public Const MQCA_Q_NAME As Short = 2016
    Public Const MQCA_QSG_NAME As Short = 2040
    Public Const MQCA_REMOTE_Q_MGR_NAME As Short = 2017
    Public Const MQCA_REMOTE_Q_NAME As Short = 2018
    Public Const MQCA_REPOSITORY_NAME As Short = 2035
    Public Const MQCA_REPOSITORY_NAMELIST As Short = 2036
    Public Const MQCA_STORAGE_CLASS As Short = 2022
    Public Const MQCA_TRIGGER_DATA As Short = 2023
    Public Const MQCA_USER_DATA As Short = 2021
    Public Const MQCA_USER_LIST As Short = 4000
    Public Const MQCA_XMIT_Q_NAME As Short = 2024

    'Integer-Attribute Selectors'
    Public Const MQIA_APPL_TYPE As Short = 1
    Public Const MQIA_ARCHIVE As Short = 60
    Public Const MQIA_AUTHORITY_EVENT As Short = 47
    Public Const MQIA_BACKOUT_THRESHOLD As Short = 22
    Public Const MQIA_CHANNEL_AUTO_DEF As Short = 55
    Public Const MQIA_CHANNEL_AUTO_DEF_EVENT As Short = 56
    Public Const MQIA_CLUSTER_Q_TYPE As Short = 59
    Public Const MQIA_CLUSTER_WORKLOAD_LENGTH As Short = 58
    Public Const MQIA_CODED_CHAR_SET_ID As Short = 2
    Public Const MQIA_COMMAND_LEVEL As Short = 31
    Public Const MQIA_CURRENT_Q_DEPTH As Short = 3
    Public Const MQIA_DEF_BIND As Short = 61
    Public Const MQIA_DEF_INPUT_OPEN_OPTION As Short = 4
    Public Const MQIA_DEF_PERSISTENCE As Short = 5
    Public Const MQIA_DEF_PRIORITY As Short = 6
    Public Const MQIA_DEFINITION_TYPE As Short = 7
    Public Const MQIA_DIST_LISTS As Short = 34
    Public Const MQIA_FIRST As Short = 1
    Public Const MQIA_HARDEN_GET_BACKOUT As Short = 8
    Public Const MQIA_HIGH_Q_DEPTH As Short = 36
    Public Const MQIA_IGQ_PUT_AUTHORITY As Short = 65
    Public Const MQIA_INDEX_TYPE As Short = 57
    Public Const MQIA_INHIBIT_EVENT As Short = 48
    Public Const MQIA_INHIBIT_GET As Short = 9
    Public Const MQIA_INHIBIT_PUT As Short = 10
    Public Const MQIA_INTRA_GROUP_QUEUING As Short = 64
    Public Const MQIA_LAST As Short = 2000
    Public Const MQIA_LAST_USED As Short = 65
    Public Const MQIA_LOCAL_EVENT As Short = 49
    Public Const MQIA_MAX_HANDLES As Short = 11
    Public Const MQIA_MAX_MSG_LENGTH As Short = 13
    Public Const MQIA_MAX_PRIORITY As Short = 14
    Public Const MQIA_MAX_Q_DEPTH As Short = 15
    Public Const MQIA_MAX_UNCOMMITTED_MSGS As Short = 33
    Public Const MQIA_MSG_DELIVERY_SEQUENCE As Short = 16
    Public Const MQIA_MSG_DEQ_COUNT As Short = 38
    Public Const MQIA_MSG_ENQ_COUNT As Short = 37
    Public Const MQIA_NAME_COUNT As Short = 19
    Public Const MQIA_OPEN_INPUT_COUNT As Short = 17
    Public Const MQIA_OPEN_OUTPUT_COUNT As Short = 18
    Public Const MQIA_PERFORMANCE_EVENT As Short = 53
    Public Const MQIA_PLATFORM As Short = 32
    Public Const MQIA_Q_DEPTH_HIGH_EVENT As Short = 43
    Public Const MQIA_Q_DEPTH_HIGH_LIMIT As Short = 40
    Public Const MQIA_Q_DEPTH_LOW_EVENT As Short = 44
    Public Const MQIA_Q_DEPTH_LOW_LIMIT As Short = 41
    Public Const MQIA_Q_DEPTH_MAX_EVENT As Short = 42
    Public Const MQIA_Q_SERVICE_INTERVAL As Short = 54
    Public Const MQIA_Q_SERVICE_INTERVAL_EVENT As Short = 46
    Public Const MQIA_Q_TYPE As Short = 20
    Public Const MQIA_QSG_DISP As Short = 63
    Public Const MQIA_REMOTE_EVENT As Short = 50
    Public Const MQIA_RETENTION_INTERVAL As Short = 21
    Public Const MQIA_SCOPE As Short = 45
    Public Const MQIA_SHAREABILITY As Short = 23
    Public Const MQIA_START_STOP_EVENT As Short = 52
    Public Const MQIA_SYNCPOINT As Short = 30
    Public Const MQIA_TIME_SINCE_RESET As Short = 35
    Public Const MQIA_TRIGGER_CONTROL As Short = 24
    Public Const MQIA_TRIGGER_DEPTH As Short = 29
    Public Const MQIA_TRIGGER_INTERVAL As Short = 25
    Public Const MQIA_TRIGGER_MSG_PRIORITY As Short = 26
    Public Const MQIA_TRIGGER_TYPE As Short = 28
    Public Const MQIA_USAGE As Short = 12
    Public Const MQIA_USER_LIST As Short = 2000

    'Integer Attribute Value Denoting "Not Applicable"'
    Public Const MQIAV_NOT_APPLICABLE As Short = -1
    Public Const MQIAV_UNDEFINED As Short = -2


    '**********************************************************************'
    '*  Values Related to MQOPEN Function                                 *'
    '**********************************************************************'

    'Open Options'
    Public Const MQOO_INPUT_AS_Q_DEF As Short = 1
    Public Const MQOO_INPUT_SHARED As Short = 2
    Public Const MQOO_INPUT_EXCLUSIVE As Short = 4
    Public Const MQOO_BROWSE As Short = 8
    Public Const MQOO_OUTPUT As Short = 16
    Public Const MQOO_INQUIRE As Short = 32
    Public Const MQOO_SET As Short = 64
    Public Const MQOO_BIND_ON_OPEN As Short = 16384
    Public Const MQOO_BIND_NOT_FIXED As Integer = 32768
    Public Const MQOO_BIND_AS_Q_DEF As Short = 0
    Public Const MQOO_SAVE_ALL_CONTEXT As Short = 128
    Public Const MQOO_PASS_IDENTITY_CONTEXT As Short = 256
    Public Const MQOO_PASS_ALL_CONTEXT As Short = 512
    Public Const MQOO_SET_IDENTITY_CONTEXT As Short = 1024
    Public Const MQOO_SET_ALL_CONTEXT As Short = 2048
    Public Const MQOO_ALTERNATE_USER_AUTHORITY As Short = 4096
    Public Const MQOO_FAIL_IF_QUIESCING As Short = 8192


    '**********************************************************************'
    '*  Values Related to All Functions                                   *'
    '**********************************************************************'

    'Connection Handle'
    Public Const MQHC_DEF_HCONN As Short = 0
    Public Const MQHC_UNUSABLE_HCONN As Short = -1

    'String Lengths'
    Public Const MQ_ABEND_CODE_LENGTH As Short = 4
    Public Const MQ_ACCOUNTING_TOKEN_LENGTH As Short = 32
    Public Const MQ_APPL_IDENTITY_DATA_LENGTH As Short = 32
    Public Const MQ_APPL_NAME_LENGTH As Short = 28
    Public Const MQ_APPL_ORIGIN_DATA_LENGTH As Short = 4
    Public Const MQ_ATTENTION_ID_LENGTH As Short = 4
    Public Const MQ_AUTHENTICATOR_LENGTH As Short = 8
    Public Const MQ_BRIDGE_NAME_LENGTH As Short = 24
    Public Const MQ_CANCEL_CODE_LENGTH As Short = 4
    Public Const MQ_CF_STRUC_NAME_LENGTH As Short = 12
    Public Const MQ_CHANNEL_DATE_LENGTH As Short = 12
    Public Const MQ_CHANNEL_DESC_LENGTH As Short = 64
    Public Const MQ_CHANNEL_NAME_LENGTH As Short = 20
    Public Const MQ_CHANNEL_TIME_LENGTH As Short = 8
    Public Const MQ_CLUSTER_NAME_LENGTH As Short = 48
    Public Const MQ_CONN_NAME_LENGTH As Short = 264
    Public Const MQ_CONN_TAG_LENGTH As Short = 128
    Public Const MQ_CORREL_ID_LENGTH As Short = 24
    Public Const MQ_CREATION_DATE_LENGTH As Short = 12
    Public Const MQ_CREATION_TIME_LENGTH As Short = 8
    Public Const MQ_DATE_LENGTH As Short = 12
    Public Const MQ_EXIT_DATA_LENGTH As Short = 32
    Public Const MQ_EXIT_NAME_LENGTH As Short = 128
    Public Const MQ_EXIT_USER_AREA_LENGTH As Short = 16
    Public Const MQ_FACILITY_LENGTH As Short = 8
    Public Const MQ_FACILITY_LIKE_LENGTH As Short = 4
    Public Const MQ_FORMAT_LENGTH As Short = 8
    Public Const MQ_FUNCTION_LENGTH As Short = 4
    Public Const MQ_GROUP_ID_LENGTH As Short = 24
    Public Const MQ_LTERM_OVERRIDE_LENGTH As Short = 8
    Public Const MQ_LUWID_LENGTH As Short = 16
    Public Const MQ_MAX_EXIT_NAME_LENGTH As Short = 128
    Public Const MQ_MAX_MCA_USER_ID_LENGTH As Short = 64
    Public Const MQ_MCA_JOB_NAME_LENGTH As Short = 28
    Public Const MQ_MCA_NAME_LENGTH As Short = 20
    Public Const MQ_MCA_USER_ID_LENGTH As Short = 64
    Public Const MQ_MFS_MAP_NAME_LENGTH As Short = 8
    Public Const MQ_MODE_NAME_LENGTH As Short = 8
    Public Const MQ_MSG_HEADER_LENGTH As Short = 4000
    Public Const MQ_MSG_ID_LENGTH As Short = 24
    Public Const MQ_MSG_TOKEN_LENGTH As Short = 16
    Public Const MQ_NAMELIST_DESC_LENGTH As Short = 64
    Public Const MQ_NAMELIST_NAME_LENGTH As Short = 48
    Public Const MQ_OBJECT_INSTANCE_ID_LENGTH As Short = 24
    Public Const MQ_OBJECT_NAME_LENGTH As Short = 48
    Public Const MQ_PASSWORD_LENGTH As Short = 12
    Public Const MQ_PROCESS_APPL_ID_LENGTH As Short = 256
    Public Const MQ_PROCESS_DESC_LENGTH As Short = 64
    Public Const MQ_PROCESS_ENV_DATA_LENGTH As Short = 128
    Public Const MQ_PROCESS_NAME_LENGTH As Short = 48
    Public Const MQ_PROCESS_USER_DATA_LENGTH As Short = 128
    Public Const MQ_PUT_APPL_NAME_LENGTH As Short = 28
    Public Const MQ_PUT_DATE_LENGTH As Short = 8
    Public Const MQ_PUT_TIME_LENGTH As Short = 8
    Public Const MQ_Q_DESC_LENGTH As Short = 64
    Public Const MQ_Q_MGR_DESC_LENGTH As Short = 64
    Public Const MQ_Q_MGR_IDENTIFIER_LENGTH As Short = 48
    Public Const MQ_Q_MGR_NAME_LENGTH As Short = 48
    Public Const MQ_Q_NAME_LENGTH As Short = 48
    Public Const MQ_QSG_NAME_LENGTH As Short = 4
    Public Const MQ_REMOTE_SYS_ID_LENGTH As Short = 4
    Public Const MQ_SECURITY_ID_LENGTH As Short = 40
    Public Const MQ_SERVICE_NAME_LENGTH As Short = 32
    Public Const MQ_SERVICE_STEP_LENGTH As Short = 8
    Public Const MQ_SHORT_CONN_NAME_LENGTH As Short = 20
    Public Const MQ_START_CODE_LENGTH As Short = 4
    Public Const MQ_STORAGE_CLASS_LENGTH As Short = 8
    Public Const MQ_TIME_LENGTH As Short = 8
    Public Const MQ_TOTAL_EXIT_DATA_LENGTH As Short = 999
    Public Const MQ_TOTAL_EXIT_NAME_LENGTH As Short = 999
    Public Const MQ_TP_NAME_LENGTH As Short = 64
    Public Const MQ_TRAN_INSTANCE_ID_LENGTH As Short = 16
    Public Const MQ_TRANSACTION_ID_LENGTH As Short = 4
    Public Const MQ_TRIGGER_DATA_LENGTH As Short = 64
    Public Const MQ_USER_ID_LENGTH As Short = 12

    'Completion Codes'
    Public Const MQCC_OK As Short = 0
    Public Const MQCC_WARNING As Short = 1
    Public Const MQCC_FAILED As Short = 2
    Public Const MQCC_UNKNOWN As Short = -1

    'Reason Codes'
    Public Const MQRC_NONE As Short = 0
    Public Const MQRC_APPL_FIRST As Short = 900
    Public Const MQRC_APPL_LAST As Short = 999
    Public Const MQRC_ALIAS_BASE_Q_TYPE_ERROR As Short = 2001
    Public Const MQRC_ALREADY_CONNECTED As Short = 2002
    Public Const MQRC_BACKED_OUT As Short = 2003
    Public Const MQRC_BUFFER_ERROR As Short = 2004
    Public Const MQRC_BUFFER_LENGTH_ERROR As Short = 2005
    Public Const MQRC_CHAR_ATTR_LENGTH_ERROR As Short = 2006
    Public Const MQRC_CHAR_ATTRS_ERROR As Short = 2007
    Public Const MQRC_CHAR_ATTRS_TOO_SHORT As Short = 2008
    Public Const MQRC_CONNECTION_BROKEN As Short = 2009
    Public Const MQRC_DATA_LENGTH_ERROR As Short = 2010
    Public Const MQRC_DYNAMIC_Q_NAME_ERROR As Short = 2011
    Public Const MQRC_ENVIRONMENT_ERROR As Short = 2012
    Public Const MQRC_EXPIRY_ERROR As Short = 2013
    Public Const MQRC_FEEDBACK_ERROR As Short = 2014
    Public Const MQRC_GET_INHIBITED As Short = 2016
    Public Const MQRC_HANDLE_NOT_AVAILABLE As Short = 2017
    Public Const MQRC_HCONN_ERROR As Short = 2018
    Public Const MQRC_HOBJ_ERROR As Short = 2019
    Public Const MQRC_INHIBIT_VALUE_ERROR As Short = 2020
    Public Const MQRC_INT_ATTR_COUNT_ERROR As Short = 2021
    Public Const MQRC_INT_ATTR_COUNT_TOO_SMALL As Short = 2022
    Public Const MQRC_INT_ATTRS_ARRAY_ERROR As Short = 2023
    Public Const MQRC_SYNCPOINT_LIMIT_REACHED As Short = 2024
    Public Const MQRC_MAX_CONNS_LIMIT_REACHED As Short = 2025
    Public Const MQRC_MD_ERROR As Short = 2026
    Public Const MQRC_MISSING_REPLY_TO_Q As Short = 2027
    Public Const MQRC_MSG_TYPE_ERROR As Short = 2029
    Public Const MQRC_MSG_TOO_BIG_FOR_Q As Short = 2030
    Public Const MQRC_MSG_TOO_BIG_FOR_Q_MGR As Short = 2031
    Public Const MQRC_NO_MSG_AVAILABLE As Short = 2033
    Public Const MQRC_NO_MSG_UNDER_CURSOR As Short = 2034
    Public Const MQRC_NOT_AUTHORIZED As Short = 2035
    Public Const MQRC_NOT_OPEN_FOR_BROWSE As Short = 2036
    Public Const MQRC_NOT_OPEN_FOR_INPUT As Short = 2037
    Public Const MQRC_NOT_OPEN_FOR_INQUIRE As Short = 2038
    Public Const MQRC_NOT_OPEN_FOR_OUTPUT As Short = 2039
    Public Const MQRC_NOT_OPEN_FOR_SET As Short = 2040
    Public Const MQRC_OBJECT_CHANGED As Short = 2041
    Public Const MQRC_OBJECT_IN_USE As Short = 2042
    Public Const MQRC_OBJECT_TYPE_ERROR As Short = 2043
    Public Const MQRC_OD_ERROR As Short = 2044
    Public Const MQRC_OPTION_NOT_VALID_FOR_TYPE As Short = 2045
    Public Const MQRC_OPTIONS_ERROR As Short = 2046
    Public Const MQRC_PERSISTENCE_ERROR As Short = 2047
    Public Const MQRC_PERSISTENT_NOT_ALLOWED As Short = 2048
    Public Const MQRC_PRIORITY_EXCEEDS_MAXIMUM As Short = 2049
    Public Const MQRC_PRIORITY_ERROR As Short = 2050
    Public Const MQRC_PUT_INHIBITED As Short = 2051
    Public Const MQRC_Q_DELETED As Short = 2052
    Public Const MQRC_Q_FULL As Short = 2053
    Public Const MQRC_Q_NOT_EMPTY As Short = 2055
    Public Const MQRC_Q_SPACE_NOT_AVAILABLE As Short = 2056
    Public Const MQRC_Q_TYPE_ERROR As Short = 2057
    Public Const MQRC_Q_MGR_NAME_ERROR As Short = 2058
    Public Const MQRC_Q_MGR_NOT_AVAILABLE As Short = 2059
    Public Const MQRC_REPORT_OPTIONS_ERROR As Short = 2061
    Public Const MQRC_SECOND_MARK_NOT_ALLOWED As Short = 2062
    Public Const MQRC_SECURITY_ERROR As Short = 2063
    Public Const MQRC_SELECTOR_COUNT_ERROR As Short = 2065
    Public Const MQRC_SELECTOR_LIMIT_EXCEEDED As Short = 2066
    Public Const MQRC_SELECTOR_ERROR As Short = 2067
    Public Const MQRC_SELECTOR_NOT_FOR_TYPE As Short = 2068
    Public Const MQRC_SIGNAL_OUTSTANDING As Short = 2069
    Public Const MQRC_SIGNAL_REQUEST_ACCEPTED As Short = 2070
    Public Const MQRC_STORAGE_NOT_AVAILABLE As Short = 2071
    Public Const MQRC_SYNCPOINT_NOT_AVAILABLE As Short = 2072
    Public Const MQRC_TRIGGER_CONTROL_ERROR As Short = 2075
    Public Const MQRC_TRIGGER_DEPTH_ERROR As Short = 2076
    Public Const MQRC_TRIGGER_MSG_PRIORITY_ERR As Short = 2077
    Public Const MQRC_TRIGGER_TYPE_ERROR As Short = 2078
    Public Const MQRC_TRUNCATED_MSG_ACCEPTED As Short = 2079
    Public Const MQRC_TRUNCATED_MSG_FAILED As Short = 2080
    Public Const MQRC_UNKNOWN_ALIAS_BASE_Q As Short = 2082
    Public Const MQRC_UNKNOWN_OBJECT_NAME As Short = 2085
    Public Const MQRC_UNKNOWN_OBJECT_Q_MGR As Short = 2086
    Public Const MQRC_UNKNOWN_REMOTE_Q_MGR As Short = 2087
    Public Const MQRC_WAIT_INTERVAL_ERROR As Short = 2090
    Public Const MQRC_XMIT_Q_TYPE_ERROR As Short = 2091
    Public Const MQRC_XMIT_Q_USAGE_ERROR As Short = 2092
    Public Const MQRC_NOT_OPEN_FOR_PASS_ALL As Short = 2093
    Public Const MQRC_NOT_OPEN_FOR_PASS_IDENT As Short = 2094
    Public Const MQRC_NOT_OPEN_FOR_SET_ALL As Short = 2095
    Public Const MQRC_NOT_OPEN_FOR_SET_IDENT As Short = 2096
    Public Const MQRC_CONTEXT_HANDLE_ERROR As Short = 2097
    Public Const MQRC_CONTEXT_NOT_AVAILABLE As Short = 2098
    Public Const MQRC_SIGNAL1_ERROR As Short = 2099
    Public Const MQRC_OBJECT_ALREADY_EXISTS As Short = 2100
    Public Const MQRC_OBJECT_DAMAGED As Short = 2101
    Public Const MQRC_RESOURCE_PROBLEM As Short = 2102
    Public Const MQRC_ANOTHER_Q_MGR_CONNECTED As Short = 2103
    Public Const MQRC_UNKNOWN_REPORT_OPTION As Short = 2104
    Public Const MQRC_STORAGE_CLASS_ERROR As Short = 2105
    Public Const MQRC_COD_NOT_VALID_FOR_XCF_Q As Short = 2106
    Public Const MQRC_SUPPRESSED_BY_EXIT As Short = 2109
    Public Const MQRC_FORMAT_ERROR As Short = 2110
    Public Const MQRC_SOURCE_CCSID_ERROR As Short = 2111
    Public Const MQRC_SOURCE_INTEGER_ENC_ERROR As Short = 2112
    Public Const MQRC_SOURCE_DECIMAL_ENC_ERROR As Short = 2113
    Public Const MQRC_SOURCE_FLOAT_ENC_ERROR As Short = 2114
    Public Const MQRC_TARGET_CCSID_ERROR As Short = 2115
    Public Const MQRC_TARGET_INTEGER_ENC_ERROR As Short = 2116
    Public Const MQRC_TARGET_DECIMAL_ENC_ERROR As Short = 2117
    Public Const MQRC_TARGET_FLOAT_ENC_ERROR As Short = 2118
    Public Const MQRC_NOT_CONVERTED As Short = 2119
    Public Const MQRC_CONVERTED_MSG_TOO_BIG As Short = 2120
    Public Const MQRC_TRUNCATED As Short = 2120
    Public Const MQRC_NO_EXTERNAL_PARTICIPANTS As Short = 2121
    Public Const MQRC_PARTICIPANT_NOT_AVAILABLE As Short = 2122
    Public Const MQRC_OUTCOME_MIXED As Short = 2123
    Public Const MQRC_OUTCOME_PENDING As Short = 2124
    Public Const MQRC_BRIDGE_STARTED As Short = 2125
    Public Const MQRC_BRIDGE_STOPPED As Short = 2126
    Public Const MQRC_ADAPTER_STORAGE_SHORTAGE As Short = 2127
    Public Const MQRC_UOW_IN_PROGRESS As Short = 2128
    Public Const MQRC_ADAPTER_CONN_LOAD_ERROR As Short = 2129
    Public Const MQRC_ADAPTER_SERV_LOAD_ERROR As Short = 2130
    Public Const MQRC_ADAPTER_DEFS_ERROR As Short = 2131
    Public Const MQRC_ADAPTER_DEFS_LOAD_ERROR As Short = 2132
    Public Const MQRC_ADAPTER_CONV_LOAD_ERROR As Short = 2133
    Public Const MQRC_BO_ERROR As Short = 2134
    Public Const MQRC_DH_ERROR As Short = 2135
    Public Const MQRC_MULTIPLE_REASONS As Short = 2136
    Public Const MQRC_OPEN_FAILED As Short = 2137
    Public Const MQRC_ADAPTER_DISC_LOAD_ERROR As Short = 2138
    Public Const MQRC_CNO_ERROR As Short = 2139
    Public Const MQRC_CICS_WAIT_FAILED As Short = 2140
    Public Const MQRC_DLH_ERROR As Short = 2141
    Public Const MQRC_HEADER_ERROR As Short = 2142
    Public Const MQRC_SOURCE_LENGTH_ERROR As Short = 2143
    Public Const MQRC_TARGET_LENGTH_ERROR As Short = 2144
    Public Const MQRC_SOURCE_BUFFER_ERROR As Short = 2145
    Public Const MQRC_TARGET_BUFFER_ERROR As Short = 2146
    Public Const MQRC_IIH_ERROR As Short = 2148
    Public Const MQRC_PCF_ERROR As Short = 2149
    Public Const MQRC_DBCS_ERROR As Short = 2150
    Public Const MQRC_OBJECT_NAME_ERROR As Short = 2152
    Public Const MQRC_OBJECT_Q_MGR_NAME_ERROR As Short = 2153
    Public Const MQRC_RECS_PRESENT_ERROR As Short = 2154
    Public Const MQRC_OBJECT_RECORDS_ERROR As Short = 2155
    Public Const MQRC_RESPONSE_RECORDS_ERROR As Short = 2156
    Public Const MQRC_ASID_MISMATCH As Short = 2157
    Public Const MQRC_PMO_RECORD_FLAGS_ERROR As Short = 2158
    Public Const MQRC_PUT_MSG_RECORDS_ERROR As Short = 2159
    Public Const MQRC_CONN_ID_IN_USE As Short = 2160
    Public Const MQRC_Q_MGR_QUIESCING As Short = 2161
    Public Const MQRC_Q_MGR_STOPPING As Short = 2162
    Public Const MQRC_DUPLICATE_RECOV_COORD As Short = 2163
    Public Const MQRC_PMO_ERROR As Short = 2173
    Public Const MQRC_API_EXIT_NOT_FOUND As Short = 2182
    Public Const MQRC_API_EXIT_LOAD_ERROR As Short = 2183
    Public Const MQRC_REMOTE_Q_NAME_ERROR As Short = 2184
    Public Const MQRC_INCONSISTENT_PERSISTENCE As Short = 2185
    Public Const MQRC_GMO_ERROR As Short = 2186
    Public Const MQRC_CICS_BRIDGE_RESTRICTION As Short = 2187
    Public Const MQRC_STOPPED_BY_CLUSTER_EXIT As Short = 2188
    Public Const MQRC_CLUSTER_RESOLUTION_ERROR As Short = 2189
    Public Const MQRC_CONVERTED_STRING_TOO_BIG As Short = 2190
    Public Const MQRC_TMC_ERROR As Short = 2191
    Public Const MQRC_PAGESET_FULL As Short = 2192
    Public Const MQRC_STORAGE_MEDIUM_FULL As Short = 2192
    Public Const MQRC_PAGESET_ERROR As Short = 2193
    Public Const MQRC_NAME_NOT_VALID_FOR_TYPE As Short = 2194
    Public Const MQRC_UNEXPECTED_ERROR As Short = 2195
    Public Const MQRC_UNKNOWN_XMIT_Q As Short = 2196
    Public Const MQRC_UNKNOWN_DEF_XMIT_Q As Short = 2197
    Public Const MQRC_DEF_XMIT_Q_TYPE_ERROR As Short = 2198
    Public Const MQRC_DEF_XMIT_Q_USAGE_ERROR As Short = 2199
    Public Const MQRC_NAME_IN_USE As Short = 2201
    Public Const MQRC_CONNECTION_QUIESCING As Short = 2202
    Public Const MQRC_CONNECTION_STOPPING As Short = 2203
    Public Const MQRC_ADAPTER_NOT_AVAILABLE As Short = 2204
    Public Const MQRC_MSG_ID_ERROR As Short = 2206
    Public Const MQRC_CORREL_ID_ERROR As Short = 2207
    Public Const MQRC_FILE_SYSTEM_ERROR As Short = 2208
    Public Const MQRC_NO_MSG_LOCKED As Short = 2209
    Public Const MQRC_FILE_NOT_AUDITED As Short = 2216
    Public Const MQRC_CONNECTION_NOT_AUTHORIZED As Short = 2217
    Public Const MQRC_MSG_TOO_BIG_FOR_CHANNEL As Short = 2218
    Public Const MQRC_CALL_IN_PROGRESS As Short = 2219
    Public Const MQRC_RMH_ERROR As Short = 2220
    Public Const MQRC_Q_MGR_ACTIVE As Short = 2222
    Public Const MQRC_Q_MGR_NOT_ACTIVE As Short = 2223
    Public Const MQRC_Q_DEPTH_HIGH As Short = 2224
    Public Const MQRC_Q_DEPTH_LOW As Short = 2225
    Public Const MQRC_Q_SERVICE_INTERVAL_HIGH As Short = 2226
    Public Const MQRC_Q_SERVICE_INTERVAL_OK As Short = 2227
    Public Const MQRC_UNIT_OF_WORK_NOT_STARTED As Short = 2232
    Public Const MQRC_CHANNEL_AUTO_DEF_OK As Short = 2233
    Public Const MQRC_CHANNEL_AUTO_DEF_ERROR As Short = 2234
    Public Const MQRC_CFH_ERROR As Short = 2235
    Public Const MQRC_CFIL_ERROR As Short = 2236
    Public Const MQRC_CFIN_ERROR As Short = 2237
    Public Const MQRC_CFSL_ERROR As Short = 2238
    Public Const MQRC_CFST_ERROR As Short = 2239
    Public Const MQRC_INCOMPLETE_GROUP As Short = 2241
    Public Const MQRC_INCOMPLETE_MSG As Short = 2242
    Public Const MQRC_INCONSISTENT_CCSIDS As Short = 2243
    Public Const MQRC_INCONSISTENT_ENCODINGS As Short = 2244
    Public Const MQRC_INCONSISTENT_UOW As Short = 2245
    Public Const MQRC_INVALID_MSG_UNDER_CURSOR As Short = 2246
    Public Const MQRC_MATCH_OPTIONS_ERROR As Short = 2247
    Public Const MQRC_MDE_ERROR As Short = 2248
    Public Const MQRC_MSG_FLAGS_ERROR As Short = 2249
    Public Const MQRC_MSG_SEQ_NUMBER_ERROR As Short = 2250
    Public Const MQRC_OFFSET_ERROR As Short = 2251
    Public Const MQRC_ORIGINAL_LENGTH_ERROR As Short = 2252
    Public Const MQRC_SEGMENT_LENGTH_ZERO As Short = 2253
    Public Const MQRC_UOW_NOT_AVAILABLE As Short = 2255
    Public Const MQRC_WRONG_GMO_VERSION As Short = 2256
    Public Const MQRC_WRONG_MD_VERSION As Short = 2257
    Public Const MQRC_GROUP_ID_ERROR As Short = 2258
    Public Const MQRC_INCONSISTENT_BROWSE As Short = 2259
    Public Const MQRC_XQH_ERROR As Short = 2260
    Public Const MQRC_SRC_ENV_ERROR As Short = 2261
    Public Const MQRC_SRC_NAME_ERROR As Short = 2262
    Public Const MQRC_DEST_ENV_ERROR As Short = 2263
    Public Const MQRC_DEST_NAME_ERROR As Short = 2264
    Public Const MQRC_TM_ERROR As Short = 2265
    Public Const MQRC_CLUSTER_EXIT_ERROR As Short = 2266
    Public Const MQRC_CLUSTER_EXIT_LOAD_ERROR As Short = 2267
    Public Const MQRC_CLUSTER_PUT_INHIBITED As Short = 2268
    Public Const MQRC_CLUSTER_RESOURCE_ERROR As Short = 2269
    Public Const MQRC_NO_DESTINATIONS_AVAILABLE As Short = 2270
    Public Const MQRC_CONN_TAG_IN_USE As Short = 2271
    Public Const MQRC_PARTIALLY_CONVERTED As Short = 2272
    Public Const MQRC_CONNECTION_ERROR As Short = 2273
    Public Const MQRC_OPTION_ENVIRONMENT_ERROR As Short = 2274
    Public Const MQRC_CD_ERROR As Short = 2277
    Public Const MQRC_CLIENT_CONN_ERROR As Short = 2278
    Public Const MQRC_CHANNEL_STOPPED_BY_USER As Short = 2279
    Public Const MQRC_HCONFIG_ERROR As Short = 2280
    Public Const MQRC_FUNCTION_ERROR As Short = 2281
    Public Const MQRC_CHANNEL_STARTED As Short = 2282
    Public Const MQRC_CHANNEL_STOPPED As Short = 2283
    Public Const MQRC_CHANNEL_CONV_ERROR As Short = 2284
    Public Const MQRC_SERVICE_NOT_AVAILABLE As Short = 2285
    Public Const MQRC_INITIALIZATION_FAILED As Short = 2286
    Public Const MQRC_TERMINATION_FAILED As Short = 2287
    Public Const MQRC_UNKNOWN_Q_NAME As Short = 2288
    Public Const MQRC_SERVICE_ERROR As Short = 2289
    Public Const MQRC_Q_ALREADY_EXISTS As Short = 2290
    Public Const MQRC_USER_ID_NOT_AVAILABLE As Short = 2291
    Public Const MQRC_UNKNOWN_ENTITY As Short = 2292
    Public Const MQRC_UNKNOWN_AUTH_ENTITY As Short = 2293
    Public Const MQRC_UNKNOWN_REF_OBJECT As Short = 2294
    Public Const MQRC_CHANNEL_ACTIVATED As Short = 2295
    Public Const MQRC_CHANNEL_NOT_ACTIVATED As Short = 2296
    Public Const MQRC_UOW_CANCELED As Short = 2297
    Public Const MQRC_FUNCTION_NOT_SUPPORTED As Short = 2298
    Public Const MQRC_SELECTOR_TYPE_ERROR As Short = 2299
    Public Const MQRC_COMMAND_TYPE_ERROR As Short = 2300
    Public Const MQRC_MULTIPLE_INSTANCE_ERROR As Short = 2301
    Public Const MQRC_SYSTEM_ITEM_NOT_ALTERABLE As Short = 2302
    Public Const MQRC_BAG_CONVERSION_ERROR As Short = 2303
    Public Const MQRC_SELECTOR_OUT_OF_RANGE As Short = 2304
    Public Const MQRC_SELECTOR_NOT_UNIQUE As Short = 2305
    Public Const MQRC_INDEX_NOT_PRESENT As Short = 2306
    Public Const MQRC_STRING_ERROR As Short = 2307
    Public Const MQRC_ENCODING_NOT_SUPPORTED As Short = 2308
    Public Const MQRC_SELECTOR_NOT_PRESENT As Short = 2309
    Public Const MQRC_OUT_SELECTOR_ERROR As Short = 2310
    Public Const MQRC_STRING_TRUNCATED As Short = 2311
    Public Const MQRC_SELECTOR_WRONG_TYPE As Short = 2312
    Public Const MQRC_INCONSISTENT_ITEM_TYPE As Short = 2313
    Public Const MQRC_INDEX_ERROR As Short = 2314
    Public Const MQRC_SYSTEM_BAG_NOT_ALTERABLE As Short = 2315
    Public Const MQRC_ITEM_COUNT_ERROR As Short = 2316
    Public Const MQRC_FORMAT_NOT_SUPPORTED As Short = 2317
    Public Const MQRC_SELECTOR_NOT_SUPPORTED As Short = 2318
    Public Const MQRC_ITEM_VALUE_ERROR As Short = 2319
    Public Const MQRC_HBAG_ERROR As Short = 2320
    Public Const MQRC_PARAMETER_MISSING As Short = 2321
    Public Const MQRC_CMD_SERVER_NOT_AVAILABLE As Short = 2322
    Public Const MQRC_STRING_LENGTH_ERROR As Short = 2323
    Public Const MQRC_INQUIRY_COMMAND_ERROR As Short = 2324
    Public Const MQRC_NESTED_BAG_NOT_SUPPORTED As Short = 2325
    Public Const MQRC_BAG_WRONG_TYPE As Short = 2326
    Public Const MQRC_ITEM_TYPE_ERROR As Short = 2327
    Public Const MQRC_SYSTEM_BAG_NOT_DELETABLE As Short = 2328
    Public Const MQRC_SYSTEM_ITEM_NOT_DELETABLE As Short = 2329
    Public Const MQRC_CODED_CHAR_SET_ID_ERROR As Short = 2330
    Public Const MQRC_MSG_TOKEN_ERROR As Short = 2331
    Public Const MQRC_MISSING_WIH As Short = 2332
    Public Const MQRC_WIH_ERROR As Short = 2333
    Public Const MQRC_RFH_ERROR As Short = 2334
    Public Const MQRC_RFH_STRING_ERROR As Short = 2335
    Public Const MQRC_RFH_COMMAND_ERROR As Short = 2336
    Public Const MQRC_RFH_PARM_ERROR As Short = 2337
    Public Const MQRC_RFH_DUPLICATE_PARM As Short = 2338
    Public Const MQRC_RFH_PARM_MISSING As Short = 2339
    Public Const MQRC_CHAR_CONVERSION_ERROR As Short = 2340
    Public Const MQRC_UCS2_CONVERSION_ERROR As Short = 2341
    Public Const MQRC_DB2_NOT_AVAILABLE As Short = 2342
    Public Const MQRC_OBJECT_NOT_UNIQUE As Short = 2343
    Public Const MQRC_CONN_TAG_NOT_RELEASED As Short = 2344
    Public Const MQRC_CF_NOT_AVAILABLE As Short = 2345
    Public Const MQRC_CF_STRUC_IN_USE As Short = 2346
    Public Const MQRC_CF_STRUC_LIST_HDR_IN_USE As Short = 2347
    Public Const MQRC_CF_STRUC_AUTH_FAILED As Short = 2348
    Public Const MQRC_CF_STRUC_ERROR As Short = 2349
    Public Const MQRC_CONN_TAG_NOT_USABLE As Short = 2350
    Public Const MQRC_GLOBAL_UOW_CONFLICT As Short = 2351
    Public Const MQRC_LOCAL_UOW_CONFLICT As Short = 2352
    Public Const MQRC_HANDLE_IN_USE_FOR_UOW As Short = 2353
    Public Const MQRC_UOW_ENLISTMENT_ERROR As Short = 2354
    Public Const MQRC_UOW_MIX_NOT_SUPPORTED As Short = 2355
    Public Const MQRC_WXP_ERROR As Short = 2356
    Public Const MQRC_CURRENT_RECORD_ERROR As Short = 2357
    Public Const MQRC_NEXT_OFFSET_ERROR As Short = 2358
    Public Const MQRC_NO_RECORD_AVAILABLE As Short = 2359
    Public Const MQRC_OBJECT_LEVEL_INCOMPATIBLE As Short = 2360
    Public Const MQRC_NEXT_RECORD_ERROR As Short = 2361


    '**********************************************************************'
    '*  Values Related to Queue Attributes                                *'
    '**********************************************************************'

    'Queue Types'
    Public Const MQQT_LOCAL As Short = 1
    Public Const MQQT_MODEL As Short = 2
    Public Const MQQT_ALIAS As Short = 3
    Public Const MQQT_REMOTE As Short = 6
    Public Const MQQT_CLUSTER As Short = 7

    'Cluster Queue Types'
    Public Const MQCQT_LOCAL_Q As Short = 1
    Public Const MQCQT_ALIAS_Q As Short = 2
    Public Const MQCQT_REMOTE_Q As Short = 3
    Public Const MQCQT_Q_MGR_ALIAS As Short = 4

    'Extended Queue Types'
    Public Const MQQT_ALL As Short = 1001

    'Queue Definition Types'
    Public Const MQQDT_PREDEFINED As Short = 1
    Public Const MQQDT_PERMANENT_DYNAMIC As Short = 2
    Public Const MQQDT_TEMPORARY_DYNAMIC As Short = 3
    Public Const MQQDT_SHARED_DYNAMIC As Short = 4

    'Inhibit Get'
    Public Const MQQA_GET_INHIBITED As Short = 1
    Public Const MQQA_GET_ALLOWED As Short = 0

    'Inhibit Put'
    Public Const MQQA_PUT_INHIBITED As Short = 1
    Public Const MQQA_PUT_ALLOWED As Short = 0

    'Queue Shareability'
    Public Const MQQA_SHAREABLE As Short = 1
    Public Const MQQA_NOT_SHAREABLE As Short = 0

    'Back-Out Hardening'
    Public Const MQQA_BACKOUT_HARDENED As Short = 1
    Public Const MQQA_BACKOUT_NOT_HARDENED As Short = 0

    'Message Delivery Sequence'
    Public Const MQMDS_PRIORITY As Short = 0
    Public Const MQMDS_FIFO As Short = 1

    'Trigger Control'
    Public Const MQTC_OFF As Short = 0
    Public Const MQTC_ON As Short = 1

    'Trigger Types'
    Public Const MQTT_NONE As Short = 0
    Public Const MQTT_FIRST As Short = 1
    Public Const MQTT_EVERY As Short = 2
    Public Const MQTT_DEPTH As Short = 3

    'Queue Usage'
    Public Const MQUS_NORMAL As Short = 0
    Public Const MQUS_TRANSMISSION As Short = 1

    'Distribution Lists'
    Public Const MQDL_SUPPORTED As Short = 1
    Public Const MQDL_NOT_SUPPORTED As Short = 0

    'Index Type'
    Public Const MQIT_NONE As Short = 0
    Public Const MQIT_MSG_ID As Short = 1
    Public Const MQIT_CORREL_ID As Short = 2
    Public Const MQIT_MSG_TOKEN As Short = 4

    'Default Bind'
    Public Const MQBND_BIND_ON_OPEN As Short = 0
    Public Const MQBND_BIND_NOT_FIXED As Short = 1

    'Queue Sharing Group Disposition'
    Public Const MQQSGD_Q_MGR As Short = 0
    Public Const MQQSGD_COPY As Short = 1
    Public Const MQQSGD_SHARED As Short = 2


    '**********************************************************************'
    '*  Values Related to Namelist Attributes                             *'
    '**********************************************************************'

    'Name Count'
    Public Const MQNC_MAX_NAMELIST_NAME_COUNT As Short = 256


    '**********************************************************************'
    '*  Values Related to Process-Definition Attributes                   *'
    '**********************************************************************'

    'Application Types'
    'See values for "Put Application Types" under MQMD'


    '**********************************************************************'
    '*  Values Related to Queue-Manager Attributes                        *'
    '**********************************************************************'

    'Command Level'
    Public Const MQCMDL_LEVEL_1 As Short = 100
    Public Const MQCMDL_LEVEL_101 As Short = 101
    Public Const MQCMDL_LEVEL_110 As Short = 110
    Public Const MQCMDL_LEVEL_114 As Short = 114
    Public Const MQCMDL_LEVEL_120 As Short = 120
    Public Const MQCMDL_LEVEL_200 As Short = 200
    Public Const MQCMDL_LEVEL_201 As Short = 201
    Public Const MQCMDL_LEVEL_210 As Short = 210
    Public Const MQCMDL_LEVEL_220 As Short = 220
    Public Const MQCMDL_LEVEL_221 As Short = 221
    Public Const MQCMDL_LEVEL_320 As Short = 320
    Public Const MQCMDL_LEVEL_420 As Short = 420
    Public Const MQCMDL_LEVEL_500 As Short = 500
    Public Const MQCMDL_LEVEL_510 As Short = 510
    Public Const MQCMDL_LEVEL_520 As Short = 520

    'Platform'
    Public Const MQPL_MVS As Short = 1
    Public Const MQPL_OS390 As Short = 1
    Public Const MQPL_OS2 As Short = 2
    Public Const MQPL_AIX As Short = 3
    Public Const MQPL_UNIX As Short = 3
    Public Const MQPL_OS400 As Short = 4
    Public Const MQPL_WINDOWS As Short = 5
    Public Const MQPL_WINDOWS_NT As Short = 11
    Public Const MQPL_VMS As Short = 12
    Public Const MQPL_NSK As Short = 13

    'Syncpoint Availability'
    Public Const MQSP_AVAILABLE As Short = 1
    Public Const MQSP_NOT_AVAILABLE As Short = 0

    'Channel Auto Definition'
    Public Const MQCHAD_DISABLED As Short = 0
    Public Const MQCHAD_ENABLED As Short = 1

    'Intra-Group Queuing'
    Public Const MQIGQ_DISABLED As Short = 0
    Public Const MQIGQ_ENABLED As Short = 1

    'Intra-Group Queuing Put Authority'
    Public Const MQIGQPA_DEFAULT As Short = 1
    Public Const MQIGQPA_CONTEXT As Short = 2
    Public Const MQIGQPA_ONLY_IGQ As Short = 3
    Public Const MQIGQPA_ALTERNATE_OR_IGQ As Short = 4

    'Distribution Lists'
    'See values for "Distribution Lists" under Queue Attributes'


    '**********************************************************************'
    '*  MQBO Structure -- Begin Options                                   *'
    '**********************************************************************'

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> Structure MQBO
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String  'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim Options As Integer 'Options that control the action of MQBEGIN'
    End Structure

    'Default Instance of MQBO Structure'
    Public MQBO_DEFAULT As MQBO


    '**********************************************************************'
    '*  MQCIH Structure -- CICS Information Header                        *'
    '**********************************************************************'

    Structure MQCIH
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim StrucLength As Integer 'Length of MQCIH structure'
        Dim Encoding As Integer 'Reserved'
        Dim CodedCharSetId As Integer 'Reserved'
        'UPGRADE_NOTE: Format was upgraded to Format_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Format_Renamed As String 'MQ format name of data that follows MQCIH'
        Dim Flags As Integer 'Flags'
        Dim ReturnCode As Integer 'Return code from bridge'
        Dim CompCode As Integer 'MQ completion code or CICS EIBRESP'
        Dim Reason As Integer 'MQ reason or feedback code, or CICS EIBRESP2'
        Dim UOWControl As Integer 'Unit-of-work control'
        Dim GetWaitInterval As Integer 'Wait interval for MQGET call issued by bridge task'
        Dim LinkType As Integer 'Link type'
        Dim OutputDataLength As Integer 'Output COMMAREA data length'
        Dim FacilityKeepTime As Integer 'Bridge facility release time'
        Dim ADSDescriptor As Integer 'Send/receive ADS descriptor'
        Dim ConversationalTask As Integer 'Whether task can be conversational'
        Dim TaskEndStatus As Integer 'Status at end of task'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Facility As String 'Bridge facility token'
        'UPGRADE_NOTE: Function was upgraded to Function_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public Function_Renamed As String 'MQ call name or CICS EIBFN function'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public AbendCode As String 'Abend code'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Authenticator As String 'Password or passticket'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Reserved1 As String 'Reserved'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public ReplyToFormat As String 'MQ format name of reply message'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public RemoteSysId As String 'Reserved'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public RemoteTransId As String 'Reserved'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public TransactionId As String 'Transaction to attach'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public FacilityLike As String 'Terminal emulated attributes'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public AttentionId As String 'AID key'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StartCode As String 'Transaction start code'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public CancelCode As String 'Abend transaction code'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public NextTransactionId As String 'Next transaction to attach'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Reserved2 As String 'Reserved'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Reserved3 As String 'Reserved'
        Dim CursorPosition As Integer 'Cursor position'
        Dim ErrorOffset As Integer 'Offset of error in message'
        Dim InputItem As Integer 'Reserved'
        Dim Reserved4 As Integer 'Reserved'
    End Structure

    'Default Instance of MQCIH Structure'
    Public MQCIH_DEFAULT As MQCIH


    '**********************************************************************'
    '*  MQCNO Structure -- Connect Options                                *'
    '**********************************************************************'

    Structure MQCNO
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim Options As Integer 'Options that control the action of MQCONNX'
        Dim ClientConnOffset As Integer 'Offset of MQCD structure for client connection'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public ClientConnPtr As String 'Address of MQCD structure for client connection'
    End Structure

    'Default Instance of MQCNO Structure'
    Public MQCNO_DEFAULT As MQCNO


    '**********************************************************************'
    '*  MQDH Structure -- Distribution Header                             *'
    '**********************************************************************'

    Structure MQDH
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim StrucLength As Integer 'Length of MQDH structure plus following records'
        Dim Encoding As Integer 'Numeric encoding of data that follows array of MQPMR records'
        Dim CodedCharSetId As Integer 'Character set identifier of data that follows array of MQPMR records'
        'UPGRADE_NOTE: Format was upgraded to Format_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Format_Renamed As String 'Format name of data that follows array of MQPMR records'
        Dim Flags As Integer 'General flags'
        Dim PutMsgRecFields As Integer 'Flags indicating which MQPMR fields are present'
        Dim RecsPresent As Integer 'Number of object records present'
        Dim ObjectRecOffset As Integer 'Offset of first object record from start of MQDH'
        Dim PutMsgRecOffset As Integer 'Offset of first put message record from start of MQDH'
    End Structure

    'Default Instance of MQDH Structure'
    Public MQDH_DEFAULT As MQDH


    '**********************************************************************'
    '*  MQDLH Structure -- Dead Letter Header                             *'
    '**********************************************************************'

    Structure MQDLH
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim Reason As Integer 'Reason message arrived on dead-letter (undelivered-message) queue'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public DestQName As String 'Name of original destination queue'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public DestQMgrName As String 'Name of original destination queue manager'
        Dim Encoding As Integer 'Numeric encoding of data that follows MQDLH'
        Dim CodedCharSetId As Integer 'Character set identifier of data that follows MQDLH'
        'UPGRADE_NOTE: Format was upgraded to Format_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Format_Renamed As String 'Format name of data that follows MQDLH'
        Dim PutApplType As Integer 'Type of application that put message on dead-letter (undelivered-message) queue'
        <VBFixedString(28), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=28)> Public PutApplName As String 'Name of application that put message on dead-letter (undelivered-message) queue'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public PutDate As String 'Date when message was put on dead-letter (undelivered-message) queue'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public PutTime As String 'Time when message was put on the dead-letter (undelivered-message) queue'
    End Structure

    'Default Instance of MQDLH Structure'
    Public MQDLH_DEFAULT As MQDLH


    '**********************************************************************'
    '*  MQGMO Structure -- Get Message Options                            *'
    '**********************************************************************'

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> _
    Structure MQGMO
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=4)> _
          Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim Options As Integer 'Options that control the action of MQGET'
        Dim WaitInterval As Integer 'Wait interval'
        Dim Signal1 As Integer 'Signal'
        Dim Signal2 As Integer 'Signal identifier'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=48)> _
          Public ResolvedQName As String 'Resolved name of destination queue'
        Dim MatchOptions As Integer 'Options controlling selection criteria used for MQGET'
        Public GroupStatus As Char 'Flag indicating whether message retrieved is in a group'
        Public SegmentStatus As Char 'Flag indicating whether message retrieved is a segment of a logical message'
        Public Segmentation As Char  'Flag indicating whether further segmentation is allowed for the message retrieved'
        Public Reserved1 As Char  'Reserved'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=16)> _
         Public MsgToken As String 'Message token'
        Dim ReturnedLength As Integer 'Length of message data returned (bytes)'
    End Structure

    'Default Instance of MQGMO Structure'
    Public MQGMO_DEFAULT As MQGMO


    '**********************************************************************'
    '*  MQIIH Structure -- IMS Information Header                         *'
    '**********************************************************************'

    Structure MQIIH
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim StrucLength As Integer 'Length of MQIIH structure'
        Dim Encoding As Integer 'Reserved'
        Dim CodedCharSetId As Integer 'Reserved'
        'UPGRADE_NOTE: Format was upgraded to Format_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Format_Renamed As String 'MQ format name of data that follows MQIIH'
        Dim Flags As Integer 'Flags'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public LTermOverride As String 'Logical terminal override'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public MFSMapName As String 'Message format services map name'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public ReplyToFormat As String 'MQ format name of reply message'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Authenticator As String 'RACF password or passticket'
        <VBFixedString(16), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=16)> Public TranInstanceId As String 'Transaction instance identifier'
        <VBFixedString(1), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=1)> Public TranState As String 'Transaction state'
        <VBFixedString(1), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=1)> Public CommitMode As String 'Commit mode'
        <VBFixedString(1), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=1)> Public SecurityScope As String 'Security scope'
        <VBFixedString(1), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=1)> Public Reserved As String 'Reserved'
    End Structure

    'Default Instance of MQIIH Structure'
    Public MQIIH_DEFAULT As MQIIH


    '**********************************************************************'
    '*  MQMD Structure -- Message Descriptor                              *'
    '**********************************************************************'

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> _
    Structure MQMD
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=4)> _
        Public StrucId As String  'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim Report As Integer 'Options for report messages'
        Dim MsgType As Integer 'Message type'
        Dim Expiry As Integer 'Message lifetime'
        Dim Feedback As Integer 'Feedback or reason code'
        Dim Encoding As Integer 'Numeric encoding of message data'
        Dim CodedCharSetId As Integer 'Character set identifier of message data'
        'UPGRADE_NOTE: Format was upgraded to Format_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=8)> Public Format_Renamed As String  'Format name of message data'
        Dim Priority As Integer 'Message priority'
        Dim Persistence As Integer 'Message persistence'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=24)> _
          Public MsgId As String 'Message identifier'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=24)> _
          Public CorrelId As String 'Correlation identifier'
        Dim BackoutCount As Integer 'Backout counter'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=48)> _
          Public ReplyToQ As String 'Name of reply queue'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=48)> _
          Public ReplyToQMgr As String 'Name of reply queue manager'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=12)> _
          Public UserIdentifier As String 'User identifier'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
          Public AccountingToken As String 'Accounting token'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
          Public ApplIdentityData As String 'Application data relating to identity'
        Dim PutApplType As Integer 'Type of application that put the message'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=28)> _
          Public PutApplName As String 'Name of application that put the message'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=8)> _
          Public PutDate As String 'Date when message was put'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=8)> _
          Public PutTime As String 'Time when message was put'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=4)> _
          Public ApplOriginData As String 'Application data relating to origin'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=24)> _
          Public GroupId As String 'Group identifier'
        Dim MsgSeqNumber As Integer 'Sequence number of logical message within group'
        Dim Offset As Integer 'Offset of data in physical message from start of logical message'
        Dim MsgFlags As Integer 'Message flags'
        Dim OriginalLength As Integer 'Length of original message'
    End Structure

    'Default Instance of MQMD Structure'
    Public MQMD_DEFAULT As MQMD


    '**********************************************************************'
    '*  MQMDE Structure -- Message Descriptor Extension                   *'
    '**********************************************************************'

    Structure MQMDE
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim StrucLength As Integer 'Length of MQMDE structure'
        Dim Encoding As Integer 'Numeric encoding of data that follows MQMDE'
        Dim CodedCharSetId As Integer 'Character-set identifier of data that follows MQMDE'
        'UPGRADE_NOTE: Format was upgraded to Format_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Format_Renamed As String 'Format name of data that follows MQMDE'
        Dim Flags As Integer 'General flags'
        <VBFixedString(24), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=24)> Public GroupId As String 'Group identifier'
        Dim MsgSeqNumber As Integer 'Sequence number of logical message within group'
        Dim Offset As Integer 'Offset of data in physical message from start of logical message'
        Dim MsgFlags As Integer 'Message flags'
        Dim OriginalLength As Integer 'Length of original message'
    End Structure

    'Default Instance of MQMDE Structure'
    Public MQMDE_DEFAULT As MQMDE


    '**********************************************************************'
    '*  MQMD1 Structure -- Version-1 Message Descriptor                   *'
    '**********************************************************************'

    Structure MQMD1
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim Report As Integer 'Report options'
        Dim MsgType As Integer 'Message type'
        Dim Expiry As Integer 'Expiry time'
        Dim Feedback As Integer 'Feedback or reason code'
        Dim Encoding As Integer 'Numeric encoding of message data'
        Dim CodedCharSetId As Integer 'Character set identifier of message data'
        'UPGRADE_NOTE: Format was upgraded to Format_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Format_Renamed As String 'Format name of message data'
        Dim Priority As Integer 'Message priority'
        Dim Persistence As Integer 'Message persistence'
        <VBFixedString(24), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=24)> Public MsgId As String 'Message identifier'
        <VBFixedString(24), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=24)> Public CorrelId As String 'Correlation identifier'
        Dim BackoutCount As Integer 'Backout counter'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public ReplyToQ As String 'Name of reply-to queue'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public ReplyToQMgr As String 'Name of reply queue manager'
        <VBFixedString(12), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=12)> Public UserIdentifier As String 'User identifier'
        <VBFixedString(32), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=32)> Public AccountingToken As String 'Accounting token'
        <VBFixedString(32), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=32)> Public ApplIdentityData As String 'Application data relating to identity'
        Dim PutApplType As Integer 'Type of application that put the message'
        <VBFixedString(28), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=28)> Public PutApplName As String 'Name of application that put the message'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public PutDate As String 'Date when message was put'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public PutTime As String 'Time when message was put'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public ApplOriginData As String 'Application data relating to origin'
    End Structure

    'Default Instance of MQMD1 Structure'
    Public MQMD1_DEFAULT As MQMD1


    '**********************************************************************'
    '*  MQOD Structure -- Object Descriptor                               *'
    '**********************************************************************'

    Structure MQOD
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim ObjectType As Integer 'Object type'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public ObjectName As String 'Object name'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public ObjectQMgrName As String 'Object queue manager name'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public DynamicQName As String 'Dynamic queue name'
        <VBFixedString(12), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=12)> Public AlternateUserId As String 'Alternate user identifier'
        Dim RecsPresent As Integer 'Number of object records present'
        Dim KnownDestCount As Integer 'Number of local queues opened successfully'
        Dim UnknownDestCount As Integer 'Number of remote queues opened successfully'
        Dim InvalidDestCount As Integer 'Number of queues that failed to open'
        Dim ObjectRecOffset As Integer 'Offset of first object record from start of MQOD'
        Dim ResponseRecOffset As Integer 'Offset of first response record from start of MQOD'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public ObjectRecPtr As String 'Address of first object record'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public ResponseRecPtr As String 'Address of first response record'
        <VBFixedString(40), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=40)> Public AlternateSecurityId As String 'Alternate security identifier'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public ResolvedQName As String 'Resolved queue name'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public ResolvedQMgrName As String 'Resolved queue manager name'
    End Structure

    'Default Instance of MQOD Structure'
    Public MQOD_DEFAULT As MQOD


    '**********************************************************************'
    '*  MQOR Structure -- Object Record                                   *'
    '**********************************************************************'

    Structure MQOR
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public ObjectName As String 'Object name'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public ObjectQMgrName As String 'Object queue manager name'
    End Structure

    'Default Instance of MQOR Structure'
    Public MQOR_DEFAULT As MQOR


    '**********************************************************************'
    '*  MQPMO Structure -- Put Message Options                            *'
    '**********************************************************************'

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> _
    Structure MQPMO
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=4)> _
          Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim Options As Integer 'Options that control the action of MQPUT and MQPUT1'
        Dim Timeout As Integer 'Reserved'
        Dim Context As Integer 'Object handle of input queue'
        Dim KnownDestCount As Integer 'Number of messages sent successfully to local queues'
        Dim UnknownDestCount As Integer 'Number of messages sent successfully to remote queues'
        Dim InvalidDestCount As Integer 'Number of messages that could not be sent'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=48)> _
          Public ResolvedQName As String 'Resolved name of destination queue'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=48)> _
          Public ResolvedQMgrName As String 'Resolved name of destination queue manager'
        Dim RecsPresent As Integer 'Number of put message records or response records present'
        Dim PutMsgRecFields As Integer 'Flags indicating which MQPMR fields are present'
        Dim PutMsgRecOffset As Integer 'Offset of first put message record from start of MQPMO'
        Dim ResponseRecOffset As Integer 'Offset of first response record from start of MQPMO'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=4)> _
          Public PutMsgRecPtr As String 'Address of first put message record'
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=4)> _
          Public ResponseRecPtr As String 'Address of first response record'
    End Structure

    'Default Instance of MQPMO Structure'
    Public MQPMO_DEFAULT As MQPMO


    '**********************************************************************'
    '*  MQPMR Structure -- Put Message Record                             *'
    '**********************************************************************'

    Structure MQPMR
        <VBFixedString(24), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=24)> Public MsgId As String 'Message identifier'
        <VBFixedString(24), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=24)> Public CorrelId As String 'Correlation identifier'
        Dim Feedback As Integer 'Feedback or reason code'
        <VBFixedString(32), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=32)> Public AccountingToken As String 'Accounting token'
    End Structure

    'Default Instance of MQPMR Structure'
    Public MQPMR_DEFAULT As MQPMR


    '**********************************************************************'
    '*  MQRFH Structure -- Rules and Formatting Header                    *'
    '**********************************************************************'

    Structure MQRFH
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim StrucLength As Integer 'Total length of MQRFH including string containing name/value pairs'
        Dim Encoding As Integer 'Numeric encoding of data that follows NameValueString'
        Dim CodedCharSetId As Integer 'Character set identifier of data that follows NameValueString'
        'UPGRADE_NOTE: Format was upgraded to Format_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Format_Renamed As String 'Format name of data that follows NameValueString'
        Dim Flags As Integer 'Flags'
    End Structure

    'Default Instance of MQRFH Structure'
    Public MQRFH_DEFAULT As MQRFH


    '**********************************************************************'
    '*  MQRFH2 Structure -- Rules and Formatting Header 2                 *'
    '**********************************************************************'

    Structure MQRFH2
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim StrucLength As Integer 'Total length of MQRFH2 including all NameValueLength and NameValueData fields'
        Dim Encoding As Integer 'Numeric encoding of data that follows NameValueData'
        Dim CodedCharSetId As Integer 'Character set identifier of data that follows NameValueData'
        'UPGRADE_NOTE: Format was upgraded to Format_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Format_Renamed As String 'Format name of data that follows NameValueData'
        Dim Flags As Integer 'Flags'
        Dim NameValueCCSID As Integer 'Character set identifier of NameValueData'
    End Structure

    'Default Instance of MQRFH2 Structure'
    Public MQRFH2_DEFAULT As MQRFH2


    '**********************************************************************'
    '*  MQRMH Structure -- Reference Message Header                       *'
    '**********************************************************************'

    Structure MQRMH
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim StrucLength As Integer 'Total length of MQRMH, including strings at end of fixed fields, but not the bulk data'
        Dim Encoding As Integer 'Numeric encoding of bulk data'
        Dim CodedCharSetId As Integer 'Character set identifier of bulk data'
        'UPGRADE_NOTE: Format was upgraded to Format_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Format_Renamed As String 'Format name of bulk data'
        Dim Flags As Integer 'Reference message flags'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public ObjectType As String 'Object type'
        <VBFixedString(24), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=24)> Public ObjectInstanceId As String 'Object instance identifier'
        Dim SrcEnvLength As Integer 'Length of source environment data'
        Dim SrcEnvOffset As Integer 'Offset of source environment data'
        Dim SrcNameLength As Integer 'Length of source object name'
        Dim SrcNameOffset As Integer 'Offset of source object name'
        Dim DestEnvLength As Integer 'Length of destination environment data'
        Dim DestEnvOffset As Integer 'Offset of destination environment data'
        Dim DestNameLength As Integer 'Length of destination object name'
        Dim DestNameOffset As Integer 'Offset of destination object name'
        Dim DataLogicalLength As Integer 'Length of bulk data'
        Dim DataLogicalOffset As Integer 'Low offset of bulk data'
        Dim DataLogicalOffset2 As Integer 'High offset of bulk data'
    End Structure

    'Default Instance of MQRMH Structure'
    Public MQRMH_DEFAULT As MQRMH


    '**********************************************************************'
    '*  MQRR Structure -- Response Record                                 *'
    '**********************************************************************'

    Structure MQRR
        Dim CompCode As Integer 'Completion code for queue'
        Dim Reason As Integer 'Reason code for queue'
    End Structure

    'Default Instance of MQRR Structure'
    Public MQRR_DEFAULT As MQRR


    '**********************************************************************'
    '*  MQTM Structure -- Trigger Message                                 *'
    '**********************************************************************'

    Structure MQTM
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public QName As String 'Name of triggered queue'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public ProcessName As String 'Name of process object'
        <VBFixedString(64), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=64)> Public TriggerData As String 'Trigger data'
        Dim ApplType As Integer 'Application type'
        <VBFixedString(256), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=256)> Public ApplId As String 'Application identifier'
        <VBFixedString(128), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=128)> Public EnvData As String 'Environment data'
        <VBFixedString(128), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=128)> Public UserData As String 'User data'
    End Structure

    'Default Instance of MQTM Structure'
    Public MQTM_DEFAULT As MQTM


    '**********************************************************************'
    '*  MQTMC2 Structure -- Trigger Message 2 (Character)                 *'
    '**********************************************************************'

    Structure MQTMC2
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public Version As String 'Structure version number'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public QName As String 'Name of triggered queue'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public ProcessName As String 'Name of process object'
        <VBFixedString(64), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=64)> Public TriggerData As String 'Trigger data'
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public ApplType As String 'Application type'
        <VBFixedString(256), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=256)> Public ApplId As String 'Application identifier'
        <VBFixedString(128), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=128)> Public EnvData As String 'Environment data'
        <VBFixedString(128), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=128)> Public UserData As String 'User data'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public QMgrName As String 'Queue manager name'
    End Structure

    'Default Instance of MQTMC2 Structure'
    Public MQTMC2_DEFAULT As MQTMC2


    '**********************************************************************'
    '*  MQWIH Structure -- Work Information Header                        *'
    '**********************************************************************'

    Structure MQWIH
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        Dim StrucLength As Integer 'Length of MQWIH structure'
        Dim Encoding As Integer 'Numeric encoding of data that follows MQWIH'
        Dim CodedCharSetId As Integer 'Character-set identifier of data that follows MQWIH'
        'UPGRADE_NOTE: Format was upgraded to Format_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public Format_Renamed As String 'Format name of data that follows MQWIH'
        Dim Flags As Integer 'Flags'
        <VBFixedString(32), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=32)> Public ServiceName As String 'Service name'
        <VBFixedString(8), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=8)> Public ServiceStep As String 'Service step name'
        <VBFixedString(16), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=16)> Public MsgToken As String 'Message token'
        <VBFixedString(32), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=32)> Public Reserved As String 'Reserved'
    End Structure

    'Default Instance of MQWIH Structure'
    Public MQWIH_DEFAULT As MQWIH


    '**********************************************************************'
    '*  MQXQH Structure -- Transmission Queue Header                      *'
    '**********************************************************************'

    Structure MQXQH
        <VBFixedString(4), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=4)> Public StrucId As String 'Structure identifier'
        Dim Version As Integer 'Structure version number'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public RemoteQName As String 'Name of destination queue'
        <VBFixedString(48), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=48)> Public RemoteQMgrName As String 'Name of destination queue manager'
        Dim MsgDesc As MQMD1 'Original message descriptor'
    End Structure

    'Default Instance of MQXQH Structure'
    Public MQXQH_DEFAULT As MQXQH


    '**********************************************************************'
    '*  Function Declarations for MQ Server Application                   *'
    '**********************************************************************'

#If MqType = 1 Then 'MQ server'
    'Name of dynamic link library'
    Public Const MQVBDLL As String = "MQM.DLL"

    'Standard MQ functions called directly from the application'
    Declare Sub MQBACK Lib "MQM.DLL" Alias "MQBACKstd@12" (ByVal Hconn As Integer, ByRef CompCode As Integer, ByRef Reason As Integer)

    'UPGRADE_WARNING: Structure MQBO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    Declare Sub MQBEGIN Lib "MQM.DLL" Alias "MQBEGINstd@16" (ByVal Hconn As Integer, ByRef BeginOptions As MQBO, ByRef CompCode As Integer, ByRef Reason As Integer)

    Declare Sub MQCLOSE Lib "MQM.DLL" Alias "MQCLOSEstd@20" (ByVal Hconn As Integer, ByRef Hobj As Integer, ByVal Options As Integer, ByRef CompCode As Integer, ByRef Reason As Integer)

    Declare Sub MQCMIT Lib "MQM.DLL" Alias "MQCMITstd@12" (ByVal Hconn As Integer, ByRef CompCode As Integer, ByRef Reason As Integer)

    Declare Sub MQCONN Lib "MQM.DLL" Alias "MQCONNstd@16" (ByVal QMgrName As String, ByRef Hconn As Integer, ByRef CompCode As Integer, ByRef Reason As Integer)

    'UPGRADE_WARNING: Structure MQCNO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    Declare Sub MQCONNX Lib "MQM.DLL" Alias "MQCONNXstd@20" (ByVal QMgrName As String, ByRef ConnectOpts As MQCNO, ByRef Hconn As Integer, ByRef CompCode As Integer, ByRef Reason As Integer)

    Declare Sub MQDISC Lib "MQM.DLL" Alias "MQDISCstd@12" (ByRef Hconn As Integer, ByRef CompCode As Integer, ByRef Reason As Integer)

    'UPGRADE_WARNING: Structure MQOD may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    Declare Sub MQOPEN Lib "MQM.DLL" Alias "MQOPENstd@24" (ByVal Hconn As Integer, ByRef ObjDesc As MQOD, ByVal Options As Integer, ByRef Hobj As Integer, ByRef CompCode As Integer, ByRef Reason As Integer)

    'Alternative form of MQ functions called directly from the application'
    'UPGRADE_ISSUE: Declaring a parameter 'As Any' is not supported. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1016"'
    'Declare Sub MQCONNXAny Lib "MQM.DLL"  Alias "MQCONNXstd@20"(ByVal QMgrName As String, ByRef ConnectOpts As Any, ByRef Hconn As Integer, ByRef CompCode As Integer, ByRef Reason As Integer)

    'UPGRADE_ISSUE: Declaring a parameter 'As Any' is not supported. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1016"'
    'UPGRADE_WARNING: Structure MQGMO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    'UPGRADE_WARNING: Structure MQMD may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    'Declare Sub MQGETAny Lib "MQM.DLL"  Alias "MQGETstd@36"(ByVal Hconn As Integer, ByVal Hobj As Integer, ByRef MsgDesc As MQMD, ByRef GetMsgOpts As MQGMO, ByVal BufferLength As Integer, ByRef Buffer As Any, ByRef DataLength As Integer, ByRef CompCode As Integer, ByRef Reason As Integer)

    'UPGRADE_ISSUE: Declaring a parameter 'As Any' is not supported. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1016"'
    'UPGRADE_WARNING: Structure MQPMO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    'UPGRADE_WARNING: Structure MQMD may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    'Declare Sub MQPUTAny Lib "MQM.DLL"  Alias "MQPUTstd@32"(ByVal Hconn As Integer, ByVal Hobj As Integer, ByRef MsgDesc As MQMD, ByRef PutMsgOpts As MQPMO, ByVal BufferLength As Integer, ByRef Buffer As Any, ByRef CompCode As Integer, ByRef Reason As Integer)

    'UPGRADE_ISSUE: Declaring a parameter 'As Any' is not supported. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1016"'
    'UPGRADE_WARNING: Structure MQPMO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    'UPGRADE_WARNING: Structure MQMD may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    'UPGRADE_WARNING: Structure MQOD may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    'Declare Sub MQPUT1Any Lib "MQM.DLL"  Alias "MQPUT1std@32"(ByVal Hconn As Integer, ByRef ObjDesc As MQOD, ByRef MsgDesc As MQMD, ByRef PutMsgOpts As MQPMO, ByVal BufferLength As Integer, ByRef Buffer As Any, ByRef CompCode As Integer, ByRef Reason As Integer)

    'Private functions used internally by MQGET, MQINQ, MQPUT, MQPUT1, MQSET'
    'UPGRADE_WARNING: Structure MQGMO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    'UPGRADE_WARNING: Structure MQMD may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    Private Declare Sub MQGETX Lib "MQM.DLL" Alias "MQGETstd@36" (ByVal Hconn As Integer, ByVal Hobj As Integer, ByRef MsgDesc As MQMD, ByRef GetMsgOpts As MQGMO, ByVal BufferLength As Integer, ByVal Buffer As String, ByRef DataLength As Integer, ByRef CompCode As Integer, ByRef Reason As Integer)

    Private Declare Sub MQINQX Lib "MQM.DLL" Alias "MQINQstd@40" (ByVal Hconn As Integer, ByVal Hobj As Integer, ByVal SelectorCount As Integer, ByRef Selectors As Integer, ByVal IntAttrCount As Integer, ByRef IntAttrs As Integer, ByVal CharAttrLength As Integer, ByVal CharAttrs As String, ByRef CompCode As Integer, ByRef Reason As Integer)

    'UPGRADE_WARNING: Structure MQPMO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    'UPGRADE_WARNING: Structure MQMD may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    Private Declare Sub MQPUTX Lib "MQM.DLL" Alias "MQPUTstd@32" (ByVal Hconn As Integer, ByVal Hobj As Integer, ByRef MsgDesc As MQMD, ByRef PutMsgOpts As MQPMO, ByVal BufferLength As Integer, ByVal Buffer As String, ByRef CompCode As Integer, ByRef Reason As Integer)

    'UPGRADE_WARNING: Structure MQPMO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    'UPGRADE_WARNING: Structure MQMD may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    'UPGRADE_WARNING: Structure MQOD may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1050"'
    Private Declare Sub MQPUT1X Lib "MQM.DLL" Alias "MQPUT1std@32" (ByVal Hconn As Integer, ByRef ObjDesc As MQOD, ByRef MsgDesc As MQMD, ByRef PutMsgOpts As MQPMO, ByVal BufferLength As Integer, ByVal Buffer As String, ByRef CompCode As Integer, ByRef Reason As Integer)

    Private Declare Sub MQSETX Lib "MQM.DLL" Alias "MQSETstd@40" (ByVal Hconn As Integer, ByVal Hobj As Integer, ByVal SelectorCount As Integer, ByRef Selectors As Integer, ByVal IntAttrCount As Integer, ByRef IntAttrs As Integer, ByVal CharAttrLength As Integer, ByVal CharAttrs As String, ByRef CompCode As Integer, ByRef Reason As Integer)


    '**********************************************************************'
    '*  Function Declarations for MQ Client Application                   *'
    '**********************************************************************'

#ElseIf MqType = 2 Then 'MQ client'
	'UPGRADE_NOTE: #If #EndIf block was not upgraded because the expression MqType = 2 did not evaluate to True or was not evaluated. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1035"'
	'Name of dynamic link library'
	Global Const MQVBDLL = "MQIC32.DLL"

	'Standard MQ functions called directly from the application'
	Declare Sub MQBACK  Lib "MQIC32.DLL" Alias "MQBACKstd@12" _
	    (ByVal Hconn    As Long, _
	           CompCode As Long, _
	           Reason   As Long)

	Declare Sub MQBEGIN Lib "MQIC32.DLL" Alias "MQBEGINstd@16" _
	    (ByVal Hconn        As Long, _
	           BeginOptions As MQBO, _
	           CompCode     As Long, _
	           Reason       As Long)

	Declare Sub MQCLOSE Lib "MQIC32.DLL" Alias "MQCLOSEstd@20" _
	    (ByVal Hconn    As Long, _
	           Hobj     As Long, _
	     ByVal Options  As Long, _
	           CompCode As Long, _
	           Reason   As Long)

	Declare Sub MQCMIT  Lib "MQIC32.DLL" Alias "MQCMITstd@12" _
	    (ByVal Hconn    As Long, _
	           CompCode As Long, _
	           Reason   As Long)

	Declare Sub MQCONN  Lib "MQIC32.DLL" Alias "MQCONNstd@16" _
	    (ByVal QMgrName As String, _
	           Hconn    As Long,   _
	           CompCode As Long,   _
	           Reason   As Long)

	Declare Sub MQCONNX Lib "MQIC32.DLL" Alias "MQCONNXstd@20" _
	    (ByVal QMgrName    As String, _
	           ConnectOpts As MQCNO,  _
	           Hconn       As Long,   _
	           CompCode    As Long,   _
	           Reason      As Long)

	Declare Sub MQDISC  Lib "MQIC32.DLL" Alias "MQDISCstd@12" _
	    (Hconn    As Long, _
	     CompCode As Long, _
	     Reason   As Long)

	Declare Sub MQOPEN  Lib "MQIC32.DLL" Alias "MQOPENstd@24" _
	    (ByVal Hconn    As Long, _
	           ObjDesc  As MQOD, _
	     ByVal Options  As Long, _
	           Hobj     As Long, _
	           CompCode As Long, _
	           Reason   As Long)

	'Alternative form of MQ functions called directly from the application'
	Declare Sub MQCONNXAny Lib "MQIC32.DLL" Alias "MQCONNXstd@20" _
	    (ByVal QMgrName    As String, _
	           ConnectOpts As Any,    _
	           Hconn       As Long,   _
	           CompCode    As Long,   _
	           Reason      As Long)

	Declare Sub MQGETAny  Lib "MQIC32.DLL" Alias "MQGETstd@36" _
	    (ByVal Hconn        As Long,  _
	     ByVal Hobj         As Long,  _
	           MsgDesc      As MQMD,  _
	           GetMsgOpts   As MQGMO, _
	     ByVal BufferLength As Long,  _
	           Buffer       As Any,   _
	           DataLength   As Long,  _
	           CompCode     As Long,  _
	           Reason       As Long)

	Declare Sub MQPUTAny  Lib "MQIC32.DLL" Alias "MQPUTstd@32" _
	    (ByVal Hconn        As Long,  _
	     ByVal Hobj         As Long,  _
	           MsgDesc      As MQMD,  _
	           PutMsgOpts   As MQPMO, _
	     ByVal BufferLength As Long,  _
	           Buffer       As Any,   _
	           CompCode     As Long,  _
	           Reason       As Long)

	Declare Sub MQPUT1Any Lib "MQIC32.DLL" Alias "MQPUT1std@32" _
	    (ByVal Hconn        As Long,  _
	           ObjDesc      As MQOD,  _
	           MsgDesc      As MQMD,  _
	           PutMsgOpts   As MQPMO, _
	     ByVal BufferLength As Long,  _
	           Buffer       As Any,   _
	           CompCode     As Long,  _
	           Reason       As Long)

	'Private functions used internally by MQGET, MQINQ, MQPUT, MQPUT1, MQSET'
	Private Declare Sub MQGETX  Lib "MQIC32.DLL" Alias "MQGETstd@36" _
	    (ByVal Hconn        As Long,   _
	     ByVal Hobj         As Long,   _
	           MsgDesc      As MQMD,   _
	           GetMsgOpts   As MQGMO,  _
	     ByVal BufferLength As Long,   _
	     ByVal Buffer       As String, _
	           DataLength   As Long,   _
	           CompCode     As Long,   _
	           Reason       As Long)

	Private Declare Sub MQINQX  Lib "MQIC32.DLL" Alias "MQINQstd@40" _
	    (ByVal Hconn          As Long,   _
	     ByVal Hobj           As Long,   _
	     ByVal SelectorCount  As Long,   _
	           Selectors      As Long,   _
	     ByVal IntAttrCount   As Long,   _
	           IntAttrs       As Long,   _
	     ByVal CharAttrLength As Long,   _
	     ByVal CharAttrs      As String, _
	           CompCode       As Long,   _
	           Reason         As Long)

	Private Declare Sub MQPUTX  Lib "MQIC32.DLL" Alias "MQPUTstd@32" _
	    (ByVal Hconn        As Long,   _
	     ByVal Hobj         As Long,   _
	           MsgDesc      As MQMD,   _
	           PutMsgOpts   As MQPMO,  _
	     ByVal BufferLength As Long,   _
	     ByVal Buffer       As String, _
	           CompCode     As Long,   _
	           Reason       As Long)

	Private Declare Sub MQPUT1X Lib "MQIC32.DLL" Alias "MQPUT1std@32" _
	    (ByVal Hconn        As Long,   _
	           ObjDesc      As MQOD,   _
	           MsgDesc      As MQMD,   _
	           PutMsgOpts   As MQPMO,  _
	     ByVal BufferLength As Long,   _
	     ByVal Buffer       As String, _
	           CompCode     As Long,   _
	           Reason       As Long)

	Private Declare Sub MQSETX  Lib "MQIC32.DLL" Alias "MQSETstd@40" _
	    (ByVal Hconn          As Long,   _
	     ByVal Hobj           As Long,   _
	     ByVal SelectorCount  As Long,   _
	           Selectors      As Long,   _
	     ByVal IntAttrCount   As Long,   _
	           IntAttrs       As Long,   _
	     ByVal CharAttrLength As Long,   _
	     ByVal CharAttrs      As String, _
	           CompCode       As Long,   _
	           Reason         As Long)

#Else
    'UPGRADE_NOTE: #If #EndIf block was not upgraded because the expression Else did not evaluate to True or was not evaluated. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1035"'
	Global Const MQVBDLL = "NONE"
    'MqType not set or set wrong'
    'Please see the comments at the top of this file'
#End If


    '**********************************************************************'
    '*  Safe Definitions of MQGET, MQINQ, MQPUT, MQPUT1, MQSET            *'
    '**********************************************************************'

    Sub MQGET(ByRef Hconn As Integer, ByRef Hobj As Integer, ByRef MsgDesc As MQMD, ByRef GetMsgOpts As MQGMO, ByRef BufferLength As Integer, ByRef Buffer As String, ByRef DataLength As Integer, ByRef CompCode As Integer, ByRef Reason As Integer)
        'UPGRADE_ISSUE: LenB function is not supported. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1040"'
        If BufferLength > Buffer.Length Then
            CompCode = MQCC_FAILED
            Reason = MQRC_BUFFER_LENGTH_ERROR
        Else
            MQGETX(Hconn, Hobj, MsgDesc, GetMsgOpts, BufferLength, Buffer, DataLength, CompCode, Reason)
        End If
    End Sub

    Sub MQINQ(ByRef Hconn As Integer, ByRef Hobj As Integer, ByRef SelectorCount As Integer, ByRef Selectors As Integer, ByRef IntAttrCount As Integer, ByRef IntAttrs As Integer, ByRef CharAttrLength As Integer, ByRef CharAttrs As String, ByRef CompCode As Integer, ByRef Reason As Integer)
        'UPGRADE_ISSUE: LenB function is not supported. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1040"'
        If CharAttrLength > CharAttrs.Length Then
            CompCode = MQCC_FAILED
            Reason = MQRC_BUFFER_LENGTH_ERROR
        Else
            MQINQX(Hconn, Hobj, SelectorCount, Selectors, IntAttrCount, IntAttrs, CharAttrLength, CharAttrs, CompCode, Reason)
        End If
    End Sub

    Sub MQPUT(ByRef Hconn As Integer, ByRef Hobj As Integer, ByRef MsgDesc As MQMD, ByRef PutMsgOpts As MQPMO, ByRef BufferLength As Integer, ByRef Buffer As String, ByRef CompCode As Integer, ByRef Reason As Integer)
        'UPGRADE_ISSUE: LenB function is not supported. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1040"'
        If BufferLength > Buffer.Length Then
            CompCode = MQCC_FAILED
            Reason = MQRC_BUFFER_LENGTH_ERROR
        Else
            MQPUTX(Hconn, Hobj, MsgDesc, PutMsgOpts, BufferLength, Buffer, CompCode, Reason)
        End If
    End Sub

    Sub MQPUT1(ByRef Hconn As Integer, ByRef ObjDesc As MQOD, ByRef MsgDesc As MQMD, ByRef PutMsgOpts As MQPMO, ByRef BufferLength As Integer, ByRef Buffer As String, ByRef CompCode As Integer, ByRef Reason As Integer)
        'UPGRADE_ISSUE: LenB function is not supported. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1040"'
        If BufferLength > Buffer.Length Then
            CompCode = MQCC_FAILED
            Reason = MQRC_BUFFER_LENGTH_ERROR
        Else
            MQPUT1X(Hconn, ObjDesc, MsgDesc, PutMsgOpts, BufferLength, Buffer, CompCode, Reason)
        End If
    End Sub

    Sub MQSET(ByRef Hconn As Integer, ByRef Hobj As Integer, ByRef SelectorCount As Integer, ByRef Selectors As Integer, ByRef IntAttrCount As Integer, ByRef IntAttrs As Integer, ByRef CharAttrLength As Integer, ByRef CharAttrs As String, ByRef CompCode As Integer, ByRef Reason As Integer)
        'UPGRADE_ISSUE: LenB function is not supported. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1040"'
        If CharAttrLength > CharAttrs.Length Then
            CompCode = MQCC_FAILED
            Reason = MQRC_BUFFER_LENGTH_ERROR
        Else
            MQSETX(Hconn, Hobj, SelectorCount, Selectors, IntAttrCount, IntAttrs, CharAttrLength, CharAttrs, CompCode, Reason)
        End If
    End Sub


    '**********************************************************************'
    '*  Subroutines to Set Structures to Default Values                   *'
    '**********************************************************************'

    Sub MQBO_DEFAULTS(ByRef Struc As MQBO)
        Struc.StrucId = MQBO_STRUC_ID
        Struc.Version = MQBO_VERSION_1
        Struc.Options = MQBO_NONE
    End Sub

    Sub MQCIH_DEFAULTS(ByRef Struc As MQCIH)
        Struc.StrucId = MQCIH_STRUC_ID
        Struc.Version = MQCIH_VERSION_2
        Struc.StrucLength = MQCIH_LENGTH_2
        Struc.Encoding = 0
        Struc.CodedCharSetId = 0
        Struc.Format_Renamed = MQFMT_NONE
        Struc.Flags = MQCIH_NONE
        Struc.ReturnCode = MQCRC_OK
        Struc.CompCode = MQCC_OK
        Struc.Reason = MQRC_NONE
        Struc.UOWControl = MQCUOWC_ONLY
        Struc.GetWaitInterval = MQCGWI_DEFAULT
        Struc.LinkType = MQCLT_PROGRAM
        Struc.OutputDataLength = MQCODL_AS_INPUT
        Struc.FacilityKeepTime = 0
        Struc.ADSDescriptor = MQCADSD_NONE
        Struc.ConversationalTask = MQCCT_NO
        Struc.TaskEndStatus = MQCTES_NOSYNC
        Struc.Facility = MQCFAC_NONE.Value
        Struc.Function_Renamed = MQCFUNC_NONE
        Struc.AbendCode = ""
        Struc.Authenticator = ""
        Struc.Reserved1 = ""
        Struc.ReplyToFormat = MQFMT_NONE
        Struc.RemoteSysId = ""
        Struc.RemoteTransId = ""
        Struc.TransactionId = ""
        Struc.FacilityLike = ""
        Struc.AttentionId = ""
        Struc.StartCode = MQCSC_NONE
        Struc.CancelCode = ""
        Struc.NextTransactionId = ""
        Struc.Reserved2 = ""
        Struc.Reserved3 = ""
        Struc.CursorPosition = 0
        Struc.ErrorOffset = 0
        Struc.InputItem = 0
        Struc.Reserved4 = 0
    End Sub

    Sub MQCNO_DEFAULTS(ByRef Struc As MQCNO)
        Struc.StrucId = MQCNO_STRUC_ID
        Struc.Version = MQCNO_VERSION_1
        Struc.Options = MQCNO_NONE
        Struc.ClientConnOffset = 0
        Struc.ClientConnPtr = New String(Chr(0), 4)
    End Sub

    Sub MQDH_DEFAULTS(ByRef Struc As MQDH)
        Struc.StrucId = MQDH_STRUC_ID
        Struc.Version = MQDH_VERSION_1
        Struc.StrucLength = 0
        Struc.Encoding = 0
        Struc.CodedCharSetId = MQCCSI_UNDEFINED
        Struc.Format_Renamed = MQFMT_NONE
        Struc.Flags = MQDHF_NONE
        Struc.PutMsgRecFields = MQPMRF_NONE
        Struc.RecsPresent = 0
        Struc.ObjectRecOffset = 0
        Struc.PutMsgRecOffset = 0
    End Sub

    Sub MQDLH_DEFAULTS(ByRef Struc As MQDLH)
        Struc.StrucId = MQDLH_STRUC_ID
        Struc.Version = MQDLH_VERSION_1
        Struc.Reason = MQRC_NONE
        Struc.DestQName = ""
        Struc.DestQMgrName = ""
        Struc.Encoding = 0
        Struc.CodedCharSetId = MQCCSI_UNDEFINED
        Struc.Format_Renamed = MQFMT_NONE
        Struc.PutApplType = 0
        Struc.PutApplName = ""
        Struc.PutDate = ""
        Struc.PutTime = ""
    End Sub

    Sub MQGMO_DEFAULTS(ByRef Struc As MQGMO)
        Struc.StrucId = MQGMO_STRUC_ID
        Struc.Version = MQGMO_VERSION_1
        Struc.Options = MQGMO_NO_WAIT
        Struc.WaitInterval = 0
        Struc.Signal1 = 0
        Struc.Signal2 = 0
        Struc.ResolvedQName = ""
        Struc.MatchOptions = MQMO_MATCH_MSG_ID + MQMO_MATCH_CORREL_ID
        Struc.GroupStatus = MQGS_NOT_IN_GROUP
        Struc.SegmentStatus = MQSS_NOT_A_SEGMENT
        Struc.Segmentation = MQSEG_INHIBITED
        Struc.Reserved1 = ""
        Struc.MsgToken = MQMTOK_NONE.Value
        Struc.ReturnedLength = MQRL_UNDEFINED
    End Sub

    Sub MQIIH_DEFAULTS(ByRef Struc As MQIIH)
        Struc.StrucId = MQIIH_STRUC_ID
        Struc.Version = MQIIH_VERSION_1
        Struc.StrucLength = MQIIH_LENGTH_1
        Struc.Encoding = 0
        Struc.CodedCharSetId = 0
        Struc.Format_Renamed = MQFMT_NONE
        Struc.Flags = MQIIH_NONE
        Struc.LTermOverride = ""
        Struc.MFSMapName = ""
        Struc.ReplyToFormat = MQFMT_NONE
        Struc.Authenticator = MQIAUT_NONE
        Struc.TranInstanceId = MQITII_NONE.Value
        Struc.TranState = MQITS_NOT_IN_CONVERSATION
        Struc.CommitMode = MQICM_COMMIT_THEN_SEND
        Struc.SecurityScope = MQISS_CHECK
        Struc.Reserved = ""
    End Sub

    Sub MQMD_DEFAULTS(ByRef Struc As MQMD)
        Struc.StrucId = MQMD_STRUC_ID
        Struc.Version = MQMD_VERSION_1
        Struc.Report = MQRO_NONE
        Struc.MsgType = MQMT_DATAGRAM
        Struc.Expiry = MQEI_UNLIMITED
        Struc.Feedback = MQFB_NONE
        Struc.Encoding = MQENC_NATIVE
        Struc.CodedCharSetId = MQCCSI_Q_MGR
        Struc.Format_Renamed = MQFMT_NONE
        Struc.Priority = MQPRI_PRIORITY_AS_Q_DEF
        Struc.Persistence = MQPER_PERSISTENCE_AS_Q_DEF
        Struc.MsgId = MQMI_NONE.Value
        Struc.CorrelId = MQCI_NONE.Value
        Struc.BackoutCount = 0
        Struc.ReplyToQ = ""
        Struc.ReplyToQMgr = ""
        Struc.UserIdentifier = ""
        Struc.AccountingToken = MQACT_NONE.Value
        Struc.ApplIdentityData = ""
        Struc.PutApplType = MQAT_NO_CONTEXT
        Struc.PutApplName = ""
        Struc.PutDate = ""
        Struc.PutTime = ""
        Struc.ApplOriginData = ""
        Struc.GroupId = MQGI_NONE.Value
        Struc.MsgSeqNumber = 1
        Struc.Offset = 0
        Struc.MsgFlags = MQMF_NONE
        Struc.OriginalLength = MQOL_UNDEFINED
    End Sub

    Sub MQMDE_DEFAULTS(ByRef Struc As MQMDE)
        Struc.StrucId = MQMDE_STRUC_ID
        Struc.Version = MQMDE_VERSION_2
        Struc.StrucLength = MQMDE_LENGTH_2
        Struc.Encoding = MQENC_NATIVE
        Struc.CodedCharSetId = MQCCSI_UNDEFINED
        Struc.Format_Renamed = MQFMT_NONE
        Struc.Flags = MQMDEF_NONE
        Struc.GroupId = MQGI_NONE.Value
        Struc.MsgSeqNumber = 1
        Struc.Offset = 0
        Struc.MsgFlags = MQMF_NONE
        Struc.OriginalLength = MQOL_UNDEFINED
    End Sub

    Sub MQMD1_DEFAULTS(ByRef Struc As MQMD1)
        Struc.StrucId = MQMD_STRUC_ID
        Struc.Version = MQMD_VERSION_1
        Struc.Report = MQRO_NONE
        Struc.MsgType = MQMT_DATAGRAM
        Struc.Expiry = MQEI_UNLIMITED
        Struc.Feedback = MQFB_NONE
        Struc.Encoding = MQENC_NATIVE
        Struc.CodedCharSetId = MQCCSI_Q_MGR
        Struc.Format_Renamed = MQFMT_NONE
        Struc.Priority = MQPRI_PRIORITY_AS_Q_DEF
        Struc.Persistence = MQPER_PERSISTENCE_AS_Q_DEF
        Struc.MsgId = MQMI_NONE.Value
        Struc.CorrelId = MQCI_NONE.Value
        Struc.BackoutCount = 0
        Struc.ReplyToQ = ""
        Struc.ReplyToQMgr = ""
        Struc.UserIdentifier = ""
        Struc.AccountingToken = MQACT_NONE.Value
        Struc.ApplIdentityData = ""
        Struc.PutApplType = MQAT_NO_CONTEXT
        Struc.PutApplName = ""
        Struc.PutDate = ""
        Struc.PutTime = ""
        Struc.ApplOriginData = ""
    End Sub

    Sub MQOD_DEFAULTS(ByRef Struc As MQOD)
        Struc.StrucId = MQOD_STRUC_ID
        Struc.Version = MQOD_VERSION_1
        Struc.ObjectType = MQOT_Q
        Struc.ObjectName = ""
        Struc.ObjectQMgrName = ""
        Struc.DynamicQName = "AMQ.*"
        Struc.AlternateUserId = ""
        Struc.RecsPresent = 0
        Struc.KnownDestCount = 0
        Struc.UnknownDestCount = 0
        Struc.InvalidDestCount = 0
        Struc.ObjectRecOffset = 0
        Struc.ResponseRecOffset = 0
        Struc.ObjectRecPtr = New String(Chr(0), 4)
        Struc.ResponseRecPtr = New String(Chr(0), 4)
        Struc.AlternateSecurityId = MQSID_NONE.Value
        Struc.ResolvedQName = ""
        Struc.ResolvedQMgrName = ""
    End Sub

    Sub MQOR_DEFAULTS(ByRef Struc As MQOR)
        Struc.ObjectName = ""
        Struc.ObjectQMgrName = ""
    End Sub

    Sub MQPMO_DEFAULTS(ByRef Struc As MQPMO)
        Struc.StrucId = MQPMO_STRUC_ID
        Struc.Version = MQPMO_VERSION_1
        Struc.Options = MQPMO_NONE
        Struc.Timeout = -1
        Struc.Context = 0
        Struc.KnownDestCount = 0
        Struc.UnknownDestCount = 0
        Struc.InvalidDestCount = 0
        Struc.ResolvedQName = ""
        Struc.ResolvedQMgrName = ""
        Struc.RecsPresent = 0
        Struc.PutMsgRecFields = MQPMRF_NONE
        Struc.PutMsgRecOffset = 0
        Struc.ResponseRecOffset = 0
        Struc.PutMsgRecPtr = New String(Chr(0), 4)
        Struc.ResponseRecPtr = New String(Chr(0), 4)
    End Sub

    Sub MQPMR_DEFAULTS(ByRef Struc As MQPMR)
        Struc.MsgId = MQMI_NONE.Value
        Struc.CorrelId = MQCI_NONE.Value
        Struc.Feedback = MQFB_NONE
        Struc.AccountingToken = MQACT_NONE.Value
    End Sub

    Sub MQRFH_DEFAULTS(ByRef Struc As MQRFH)
        Struc.StrucId = MQRFH_STRUC_ID
        Struc.Version = MQRFH_VERSION_1
        Struc.StrucLength = MQRFH_STRUC_LENGTH_FIXED
        Struc.Encoding = MQENC_NATIVE
        Struc.CodedCharSetId = MQCCSI_UNDEFINED
        Struc.Format_Renamed = MQFMT_NONE
        Struc.Flags = MQRFH_NONE
    End Sub

    Sub MQRFH2_DEFAULTS(ByRef Struc As MQRFH2)
        Struc.StrucId = MQRFH_STRUC_ID
        Struc.Version = MQRFH_VERSION_2
        Struc.StrucLength = MQRFH_STRUC_LENGTH_FIXED_2
        Struc.Encoding = MQENC_NATIVE
        Struc.CodedCharSetId = MQCCSI_INHERIT
        Struc.Format_Renamed = MQFMT_NONE
        Struc.Flags = MQRFH_NONE
        Struc.NameValueCCSID = 1208
    End Sub

    Sub MQRMH_DEFAULTS(ByRef Struc As MQRMH)
        Struc.StrucId = MQRMH_STRUC_ID
        Struc.Version = MQRMH_VERSION_1
        Struc.StrucLength = 0
        Struc.Encoding = MQENC_NATIVE
        Struc.CodedCharSetId = MQCCSI_UNDEFINED
        Struc.Format_Renamed = MQFMT_NONE
        Struc.Flags = MQRMHF_NOT_LAST
        Struc.ObjectType = ""
        Struc.ObjectInstanceId = MQOII_NONE.Value
        Struc.SrcEnvLength = 0
        Struc.SrcEnvOffset = 0
        Struc.SrcNameLength = 0
        Struc.SrcNameOffset = 0
        Struc.DestEnvLength = 0
        Struc.DestEnvOffset = 0
        Struc.DestNameLength = 0
        Struc.DestNameOffset = 0
        Struc.DataLogicalLength = 0
        Struc.DataLogicalOffset = 0
        Struc.DataLogicalOffset2 = 0
    End Sub

    Sub MQRR_DEFAULTS(ByRef Struc As MQRR)
        Struc.CompCode = MQCC_OK
        Struc.Reason = MQRC_NONE
    End Sub

    Sub MQTM_DEFAULTS(ByRef Struc As MQTM)
        Struc.StrucId = MQTM_STRUC_ID
        Struc.Version = MQTM_VERSION_1
        Struc.QName = ""
        Struc.ProcessName = ""
        Struc.TriggerData = ""
        Struc.ApplType = 0
        Struc.ApplId = ""
        Struc.EnvData = ""
        Struc.UserData = ""
    End Sub

    Sub MQTMC2_DEFAULTS(ByRef Struc As MQTMC2)
        Struc.StrucId = MQTMC_STRUC_ID
        Struc.Version = MQTMC_VERSION_2
        Struc.QName = ""
        Struc.ProcessName = ""
        Struc.TriggerData = ""
        Struc.ApplType = ""
        Struc.ApplId = ""
        Struc.EnvData = ""
        Struc.UserData = ""
        Struc.QMgrName = ""
    End Sub

    Sub MQWIH_DEFAULTS(ByRef Struc As MQWIH)
        Struc.StrucId = MQWIH_STRUC_ID
        Struc.Version = MQWIH_VERSION_1
        Struc.StrucLength = MQWIH_LENGTH_1
        Struc.Encoding = 0
        Struc.CodedCharSetId = MQCCSI_UNDEFINED
        Struc.Format_Renamed = MQFMT_NONE
        Struc.Flags = MQWIH_NONE
        Struc.ServiceName = ""
        Struc.ServiceStep = ""
        Struc.MsgToken = MQMTOK_NONE.Value
        Struc.Reserved = ""
    End Sub

    Sub MQXQH_DEFAULTS(ByRef Struc As MQXQH)
        Struc.StrucId = MQXQH_STRUC_ID
        Struc.Version = MQXQH_VERSION_1
        Struc.RemoteQName = ""
        Struc.RemoteQMgrName = ""
        Dim TempMsgDesc As MQMD1
        MQMD1_DEFAULTS(TempMsgDesc)
        'UPGRADE_WARNING: Couldn't resolve default property of object Struc.MsgDesc. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
        Struc.MsgDesc = TempMsgDesc
    End Sub


    '**********************************************************************'
    '*  MQ_SETDEFAULTS Subroutine -- Set Defaults                         *'
    '**********************************************************************'

    Sub MQ_SETDEFAULTS()
        'Check that MQType has been set'
        If MQVBDLL = "NONE" Then
            MsgBox("MQType has not been set correctly" & Chr(10) & Chr(13) & "Please see the comments at the start of CMQB.BAS", MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "Error")
        End If

        'Set byte-string constants'
        MQCFAC_NONE.Value = New String(Chr(0), 8)
        MQMTOK_NONE.Value = New String(Chr(0), 16)
        MQITII_NONE.Value = New String(Chr(0), 16)
        MQMI_NONE.Value = New String(Chr(0), 24)
        MQCI_NONE.Value = New String(Chr(0), 24)
        MQCI_NEW_SESSION.Value = Chr(&H41S) & Chr(&H4DS) & Chr(&H51S) & Chr(&H21S) & Chr(&H4ES) & Chr(&H45S) & Chr(&H57S) & Chr(&H5FS) & Chr(&H53S) & Chr(&H45S) & Chr(&H53S) & Chr(&H53S) & Chr(&H49S) & Chr(&H4FS) & Chr(&H4ES) & Chr(&H5FS) & Chr(&H43S) & Chr(&H4FS) & Chr(&H52S) & Chr(&H52S) & Chr(&H45S) & Chr(&H4CS) & Chr(&H49S) & Chr(&H44S)
        MQACT_NONE.Value = New String(Chr(0), 32)
        MQACTT_UNKNOWN.Value = Chr(0)
        MQACTT_CICS_LUOW_ID.Value = Chr(1)
        MQACTT_OS2_DEFAULT.Value = Chr(4)
        MQACTT_DOS_DEFAULT.Value = Chr(5)
        MQACTT_UNIX_NUMERIC_ID.Value = Chr(6)
        MQACTT_OS400_ACCOUNT_TOKEN.Value = Chr(8)
        MQACTT_WINDOWS_DEFAULT.Value = Chr(9)
        MQACTT_NT_SECURITY_ID.Value = Chr(11)
        MQACTT_USER.Value = Chr(25)
        MQGI_NONE.Value = New String(Chr(0), 24)
        MQSID_NONE.Value = New String(Chr(0), 40)
        MQSIDT_NONE.Value = Chr(0)
        MQSIDT_NT_SECURITY_ID.Value = Chr(1)
        MQOII_NONE.Value = New String(Chr(0), 24)

        'Set default structures'
        MQBO_DEFAULTS(MQBO_DEFAULT)
        MQCIH_DEFAULTS(MQCIH_DEFAULT)
        MQCNO_DEFAULTS(MQCNO_DEFAULT)
        MQDH_DEFAULTS(MQDH_DEFAULT)
        MQDLH_DEFAULTS(MQDLH_DEFAULT)
        MQGMO_DEFAULTS(MQGMO_DEFAULT)
        MQIIH_DEFAULTS(MQIIH_DEFAULT)
        MQMD_DEFAULTS(MQMD_DEFAULT)
        MQMDE_DEFAULTS(MQMDE_DEFAULT)
        MQMD1_DEFAULTS(MQMD1_DEFAULT)
        MQOD_DEFAULTS(MQOD_DEFAULT)
        MQOR_DEFAULTS(MQOR_DEFAULT)
        MQPMO_DEFAULTS(MQPMO_DEFAULT)
        MQPMR_DEFAULTS(MQPMR_DEFAULT)
        MQRFH_DEFAULTS(MQRFH_DEFAULT)
        MQRFH2_DEFAULTS(MQRFH2_DEFAULT)
        MQRMH_DEFAULTS(MQRMH_DEFAULT)
        MQRR_DEFAULTS(MQRR_DEFAULT)
        MQTM_DEFAULTS(MQTM_DEFAULT)
        MQTMC2_DEFAULTS(MQTMC2_DEFAULT)
        MQWIH_DEFAULTS(MQWIH_DEFAULT)
        MQXQH_DEFAULTS(MQXQH_DEFAULT)
    End Sub


    '**********************************************************************'
    '*  End of CMQB                                                       *'
    '**********************************************************************'
End Module