Option Strict Off
Option Explicit On
Module CMQCFB
	'**********************************************************************'
	'*                                                                    *'
	'*                  IBM MQSeries for Windows NT and Windows 2000      *'
	'*                                                                    *'
	'*  MODULE NAME:    CMQCFB                                            *'
	'*                                                                    *'
	'*  DESCRIPTION:    Declarations for PCF and Events                   *'
	'*                                                                    *'
	'**********************************************************************'
	'*  @START_COPYRIGHT@                                                 *'
	'*  Licensed Materials - Property of IBM                              *'
	'*                                                                    *'
	'*  0784726, 5639-B43  MQSeries for Windows NT and Windows 2000       *'
	'*                                                                    *'
	'*  (C) Copyright IBM Corporation 1995, 2000.                         *'
	'*                                                                    *'
	'*  Status: Version 5 Release 2                                       *'
	'*  @END_COPYRIGHT@                                                   *'
	'**********************************************************************'
	'*                                                                    *'
	'*  FUNCTION:       This file declares the structures and named       *'
	'*                  constants for PCF and event messages.             *'
	'*                                                                    *'
	'*  PROCESSOR:      BASIC                                             *'
	'*                                                                    *'
	'**********************************************************************'
	
	'**********************************************************************'
	'*  Values Related to MQCFH Structure                                 *'
	'**********************************************************************'
	
	'Structure Length'
	Public Const MQCFH_STRUC_LENGTH As Short = 36
	
	'Structure Version Number'
	Public Const MQCFH_VERSION_1 As Short = 1
	Public Const MQCFH_CURRENT_VERSION As Short = 1
	
	'Command Codes'
	Public Const MQCMD_CHANGE_Q_MGR As Short = 1
	Public Const MQCMD_INQUIRE_Q_MGR As Short = 2
	Public Const MQCMD_CHANGE_PROCESS As Short = 3
	Public Const MQCMD_COPY_PROCESS As Short = 4
	Public Const MQCMD_CREATE_PROCESS As Short = 5
	Public Const MQCMD_DELETE_PROCESS As Short = 6
	Public Const MQCMD_INQUIRE_PROCESS As Short = 7
	Public Const MQCMD_CHANGE_Q As Short = 8
	Public Const MQCMD_CLEAR_Q As Short = 9
	Public Const MQCMD_COPY_Q As Short = 10
	Public Const MQCMD_CREATE_Q As Short = 11
	Public Const MQCMD_DELETE_Q As Short = 12
	Public Const MQCMD_INQUIRE_Q As Short = 13
	Public Const MQCMD_RESET_Q_STATS As Short = 17
	Public Const MQCMD_INQUIRE_Q_NAMES As Short = 18
	Public Const MQCMD_INQUIRE_PROCESS_NAMES As Short = 19
	Public Const MQCMD_INQUIRE_CHANNEL_NAMES As Short = 20
	Public Const MQCMD_CHANGE_CHANNEL As Short = 21
	Public Const MQCMD_COPY_CHANNEL As Short = 22
	Public Const MQCMD_CREATE_CHANNEL As Short = 23
	Public Const MQCMD_DELETE_CHANNEL As Short = 24
	Public Const MQCMD_INQUIRE_CHANNEL As Short = 25
	Public Const MQCMD_PING_CHANNEL As Short = 26
	Public Const MQCMD_RESET_CHANNEL As Short = 27
	Public Const MQCMD_START_CHANNEL As Short = 28
	Public Const MQCMD_STOP_CHANNEL As Short = 29
	Public Const MQCMD_START_CHANNEL_INIT As Short = 30
	Public Const MQCMD_START_CHANNEL_LISTENER As Short = 31
	Public Const MQCMD_CHANGE_NAMELIST As Short = 32
	Public Const MQCMD_COPY_NAMELIST As Short = 33
	Public Const MQCMD_CREATE_NAMELIST As Short = 34
	Public Const MQCMD_DELETE_NAMELIST As Short = 35
	Public Const MQCMD_INQUIRE_NAMELIST As Short = 36
	Public Const MQCMD_INQUIRE_NAMELIST_NAMES As Short = 37
	Public Const MQCMD_ESCAPE As Short = 38
	Public Const MQCMD_RESOLVE_CHANNEL As Short = 39
	Public Const MQCMD_PING_Q_MGR As Short = 40
	Public Const MQCMD_INQUIRE_CHANNEL_STATUS As Short = 42
	Public Const MQCMD_Q_MGR_EVENT As Short = 44
	Public Const MQCMD_PERFM_EVENT As Short = 45
	Public Const MQCMD_CHANNEL_EVENT As Short = 46
	Public Const MQCMD_DELETE_PUBLICATION As Short = 60
	Public Const MQCMD_DEREGISTER_PUBLISHER As Short = 61
	Public Const MQCMD_DEREGISTER_SUBSCRIBER As Short = 62
	Public Const MQCMD_PUBLISH As Short = 63
	Public Const MQCMD_REGISTER_PUBLISHER As Short = 64
	Public Const MQCMD_REGISTER_SUBSCRIBER As Short = 65
	Public Const MQCMD_REQUEST_UPDATE As Short = 66
	Public Const MQCMD_BROKER_INTERNAL As Short = 67
	Public Const MQCMD_INQUIRE_CLUSTER_Q_MGR As Short = 70
	Public Const MQCMD_RESUME_Q_MGR_CLUSTER As Short = 71
	Public Const MQCMD_SUSPEND_Q_MGR_CLUSTER As Short = 72
	Public Const MQCMD_REFRESH_CLUSTER As Short = 73
	Public Const MQCMD_RESET_CLUSTER As Short = 74
	Public Const MQCMD_REFRESH_SECURITY As Short = 78
	Public Const MQCMD_NONE As Short = 0
	
	'Control Options'
	Public Const MQCFC_LAST As Short = 1
	Public Const MQCFC_NOT_LAST As Short = 0
	
	'Reason Codes'
	Public Const MQRCCF_CFH_TYPE_ERROR As Short = 3001
	Public Const MQRCCF_CFH_LENGTH_ERROR As Short = 3002
	Public Const MQRCCF_CFH_VERSION_ERROR As Short = 3003
	Public Const MQRCCF_CFH_MSG_SEQ_NUMBER_ERR As Short = 3004
	Public Const MQRCCF_CFH_CONTROL_ERROR As Short = 3005
	Public Const MQRCCF_CFH_PARM_COUNT_ERROR As Short = 3006
	Public Const MQRCCF_CFH_COMMAND_ERROR As Short = 3007
	Public Const MQRCCF_COMMAND_FAILED As Short = 3008
	Public Const MQRCCF_CFIN_LENGTH_ERROR As Short = 3009
	Public Const MQRCCF_CFST_LENGTH_ERROR As Short = 3010
	Public Const MQRCCF_CFST_STRING_LENGTH_ERR As Short = 3011
	Public Const MQRCCF_FORCE_VALUE_ERROR As Short = 3012
	Public Const MQRCCF_STRUCTURE_TYPE_ERROR As Short = 3013
	Public Const MQRCCF_CFIN_PARM_ID_ERROR As Short = 3014
	Public Const MQRCCF_CFST_PARM_ID_ERROR As Short = 3015
	Public Const MQRCCF_MSG_LENGTH_ERROR As Short = 3016
	Public Const MQRCCF_CFIN_DUPLICATE_PARM As Short = 3017
	Public Const MQRCCF_CFST_DUPLICATE_PARM As Short = 3018
	Public Const MQRCCF_PARM_COUNT_TOO_SMALL As Short = 3019
	Public Const MQRCCF_PARM_COUNT_TOO_BIG As Short = 3020
	Public Const MQRCCF_Q_ALREADY_IN_CELL As Short = 3021
	Public Const MQRCCF_Q_TYPE_ERROR As Short = 3022
	Public Const MQRCCF_MD_FORMAT_ERROR As Short = 3023
	Public Const MQRCCF_CFSL_LENGTH_ERROR As Short = 3024
	Public Const MQRCCF_REPLACE_VALUE_ERROR As Short = 3025
	Public Const MQRCCF_CFIL_DUPLICATE_VALUE As Short = 3026
	Public Const MQRCCF_CFIL_COUNT_ERROR As Short = 3027
	Public Const MQRCCF_CFIL_LENGTH_ERROR As Short = 3028
	Public Const MQRCCF_QUIESCE_VALUE_ERROR As Short = 3029
	Public Const MQRCCF_MSG_SEQ_NUMBER_ERROR As Short = 3030
	Public Const MQRCCF_PING_DATA_COUNT_ERROR As Short = 3031
	Public Const MQRCCF_PING_DATA_COMPARE_ERROR As Short = 3032
	Public Const MQRCCF_CFSL_PARM_ID_ERROR As Short = 3033
	Public Const MQRCCF_CHANNEL_TYPE_ERROR As Short = 3034
	Public Const MQRCCF_PARM_SEQUENCE_ERROR As Short = 3035
	Public Const MQRCCF_XMIT_PROTOCOL_TYPE_ERR As Short = 3036
	Public Const MQRCCF_BATCH_SIZE_ERROR As Short = 3037
	Public Const MQRCCF_DISC_INT_ERROR As Short = 3038
	Public Const MQRCCF_SHORT_RETRY_ERROR As Short = 3039
	Public Const MQRCCF_SHORT_TIMER_ERROR As Short = 3040
	Public Const MQRCCF_LONG_RETRY_ERROR As Short = 3041
	Public Const MQRCCF_LONG_TIMER_ERROR As Short = 3042
	Public Const MQRCCF_SEQ_NUMBER_WRAP_ERROR As Short = 3043
	Public Const MQRCCF_MAX_MSG_LENGTH_ERROR As Short = 3044
	Public Const MQRCCF_PUT_AUTH_ERROR As Short = 3045
	Public Const MQRCCF_PURGE_VALUE_ERROR As Short = 3046
	Public Const MQRCCF_CFIL_PARM_ID_ERROR As Short = 3047
	Public Const MQRCCF_MSG_TRUNCATED As Short = 3048
	Public Const MQRCCF_CCSID_ERROR As Short = 3049
	Public Const MQRCCF_ENCODING_ERROR As Short = 3050
	Public Const MQRCCF_DATA_CONV_VALUE_ERROR As Short = 3052
	Public Const MQRCCF_INDOUBT_VALUE_ERROR As Short = 3053
	Public Const MQRCCF_ESCAPE_TYPE_ERROR As Short = 3054
	Public Const MQRCCF_CHANNEL_TABLE_ERROR As Short = 3062
	Public Const MQRCCF_MCA_TYPE_ERROR As Short = 3063
	Public Const MQRCCF_CHL_INST_TYPE_ERROR As Short = 3064
	Public Const MQRCCF_CHL_STATUS_NOT_FOUND As Short = 3065
	Public Const MQRCCF_CFSL_DUPLICATE_PARM As Short = 3066
	Public Const MQRCCF_CFSL_TOTAL_LENGTH_ERROR As Short = 3067
	Public Const MQRCCF_CFSL_COUNT_ERROR As Short = 3068
	Public Const MQRCCF_CFSL_STRING_LENGTH_ERR As Short = 3069
	Public Const MQRCCF_BROKER_DELETED As Short = 3070
	Public Const MQRCCF_STREAM_ERROR As Short = 3071
	Public Const MQRCCF_TOPIC_ERROR As Short = 3072
	Public Const MQRCCF_NOT_REGISTERED As Short = 3073
	Public Const MQRCCF_Q_MGR_NAME_ERROR As Short = 3074
	Public Const MQRCCF_INCORRECT_STREAM As Short = 3075
	Public Const MQRCCF_Q_NAME_ERROR As Short = 3076
	Public Const MQRCCF_NO_RETAINED_MSG As Short = 3077
	Public Const MQRCCF_DUPLICATE_IDENTITY As Short = 3078
	Public Const MQRCCF_INCORRECT_Q As Short = 3079
	Public Const MQRCCF_CORREL_ID_ERROR As Short = 3080
	Public Const MQRCCF_NOT_AUTHORIZED As Short = 3081
	Public Const MQRCCF_UNKNOWN_STREAM As Short = 3082
	Public Const MQRCCF_REG_OPTIONS_ERROR As Short = 3083
	Public Const MQRCCF_PUB_OPTIONS_ERROR As Short = 3084
	Public Const MQRCCF_UNKNOWN_BROKER As Short = 3085
	Public Const MQRCCF_Q_MGR_CCSID_ERROR As Short = 3086
	Public Const MQRCCF_DEL_OPTIONS_ERROR As Short = 3087
	Public Const MQRCCF_CLUSTER_NAME_CONFLICT As Short = 3088
	Public Const MQRCCF_REPOS_NAME_CONFLICT As Short = 3089
	Public Const MQRCCF_CLUSTER_Q_USAGE_ERROR As Short = 3090
	Public Const MQRCCF_ACTION_VALUE_ERROR As Short = 3091
	Public Const MQRCCF_COMMS_LIBRARY_ERROR As Short = 3092
	Public Const MQRCCF_NETBIOS_NAME_ERROR As Short = 3093
	Public Const MQRCCF_BROKER_COMMAND_FAILED As Short = 3094
	Public Const MQRCCF_FILTER_ERROR As Short = 3150
	Public Const MQRCCF_WRONG_USER As Short = 3151
	Public Const MQRCCF_OBJECT_ALREADY_EXISTS As Short = 4001
	Public Const MQRCCF_OBJECT_WRONG_TYPE As Short = 4002
	Public Const MQRCCF_LIKE_OBJECT_WRONG_TYPE As Short = 4003
	Public Const MQRCCF_OBJECT_OPEN As Short = 4004
	Public Const MQRCCF_ATTR_VALUE_ERROR As Short = 4005
	Public Const MQRCCF_UNKNOWN_Q_MGR As Short = 4006
	Public Const MQRCCF_Q_WRONG_TYPE As Short = 4007
	Public Const MQRCCF_OBJECT_NAME_ERROR As Short = 4008
	Public Const MQRCCF_ALLOCATE_FAILED As Short = 4009
	Public Const MQRCCF_HOST_NOT_AVAILABLE As Short = 4010
	Public Const MQRCCF_CONFIGURATION_ERROR As Short = 4011
	Public Const MQRCCF_CONNECTION_REFUSED As Short = 4012
	Public Const MQRCCF_ENTRY_ERROR As Short = 4013
	Public Const MQRCCF_SEND_FAILED As Short = 4014
	Public Const MQRCCF_RECEIVED_DATA_ERROR As Short = 4015
	Public Const MQRCCF_RECEIVE_FAILED As Short = 4016
	Public Const MQRCCF_CONNECTION_CLOSED As Short = 4017
	Public Const MQRCCF_NO_STORAGE As Short = 4018
	Public Const MQRCCF_NO_COMMS_MANAGER As Short = 4019
	Public Const MQRCCF_LISTENER_NOT_STARTED As Short = 4020
	Public Const MQRCCF_BIND_FAILED As Short = 4024
	Public Const MQRCCF_CHANNEL_INDOUBT As Short = 4025
	Public Const MQRCCF_MQCONN_FAILED As Short = 4026
	Public Const MQRCCF_MQOPEN_FAILED As Short = 4027
	Public Const MQRCCF_MQGET_FAILED As Short = 4028
	Public Const MQRCCF_MQPUT_FAILED As Short = 4029
	Public Const MQRCCF_PING_ERROR As Short = 4030
	Public Const MQRCCF_CHANNEL_IN_USE As Short = 4031
	Public Const MQRCCF_CHANNEL_NOT_FOUND As Short = 4032
	Public Const MQRCCF_UNKNOWN_REMOTE_CHANNEL As Short = 4033
	Public Const MQRCCF_REMOTE_QM_UNAVAILABLE As Short = 4034
	Public Const MQRCCF_REMOTE_QM_TERMINATING As Short = 4035
	Public Const MQRCCF_MQINQ_FAILED As Short = 4036
	Public Const MQRCCF_NOT_XMIT_Q As Short = 4037
	Public Const MQRCCF_CHANNEL_DISABLED As Short = 4038
	Public Const MQRCCF_USER_EXIT_NOT_AVAILABLE As Short = 4039
	Public Const MQRCCF_COMMIT_FAILED As Short = 4040
	Public Const MQRCCF_CHANNEL_ALREADY_EXISTS As Short = 4042
	Public Const MQRCCF_DATA_TOO_LARGE As Short = 4043
	Public Const MQRCCF_CHANNEL_NAME_ERROR As Short = 4044
	Public Const MQRCCF_XMIT_Q_NAME_ERROR As Short = 4045
	Public Const MQRCCF_MCA_NAME_ERROR As Short = 4047
	Public Const MQRCCF_SEND_EXIT_NAME_ERROR As Short = 4048
	Public Const MQRCCF_SEC_EXIT_NAME_ERROR As Short = 4049
	Public Const MQRCCF_MSG_EXIT_NAME_ERROR As Short = 4050
	Public Const MQRCCF_RCV_EXIT_NAME_ERROR As Short = 4051
	Public Const MQRCCF_XMIT_Q_NAME_WRONG_TYPE As Short = 4052
	Public Const MQRCCF_MCA_NAME_WRONG_TYPE As Short = 4053
	Public Const MQRCCF_DISC_INT_WRONG_TYPE As Short = 4054
	Public Const MQRCCF_SHORT_RETRY_WRONG_TYPE As Short = 4055
	Public Const MQRCCF_SHORT_TIMER_WRONG_TYPE As Short = 4056
	Public Const MQRCCF_LONG_RETRY_WRONG_TYPE As Short = 4057
	Public Const MQRCCF_LONG_TIMER_WRONG_TYPE As Short = 4058
	Public Const MQRCCF_PUT_AUTH_WRONG_TYPE As Short = 4059
	Public Const MQRCCF_MISSING_CONN_NAME As Short = 4061
	Public Const MQRCCF_CONN_NAME_ERROR As Short = 4062
	Public Const MQRCCF_MQSET_FAILED As Short = 4063
	Public Const MQRCCF_CHANNEL_NOT_ACTIVE As Short = 4064
	Public Const MQRCCF_TERMINATED_BY_SEC_EXIT As Short = 4065
	Public Const MQRCCF_DYNAMIC_Q_SCOPE_ERROR As Short = 4067
	Public Const MQRCCF_CELL_DIR_NOT_AVAILABLE As Short = 4068
	Public Const MQRCCF_MR_COUNT_ERROR As Short = 4069
	Public Const MQRCCF_MR_COUNT_WRONG_TYPE As Short = 4070
	Public Const MQRCCF_MR_EXIT_NAME_ERROR As Short = 4071
	Public Const MQRCCF_MR_EXIT_NAME_WRONG_TYPE As Short = 4072
	Public Const MQRCCF_MR_INTERVAL_ERROR As Short = 4073
	Public Const MQRCCF_MR_INTERVAL_WRONG_TYPE As Short = 4074
	Public Const MQRCCF_NPM_SPEED_ERROR As Short = 4075
	Public Const MQRCCF_NPM_SPEED_WRONG_TYPE As Short = 4076
	Public Const MQRCCF_HB_INTERVAL_ERROR As Short = 4077
	Public Const MQRCCF_HB_INTERVAL_WRONG_TYPE As Short = 4078
	Public Const MQRCCF_CHAD_ERROR As Short = 4079
	Public Const MQRCCF_CHAD_WRONG_TYPE As Short = 4080
	Public Const MQRCCF_CHAD_EVENT_ERROR As Short = 4081
	Public Const MQRCCF_CHAD_EVENT_WRONG_TYPE As Short = 4082
	Public Const MQRCCF_CHAD_EXIT_ERROR As Short = 4083
	Public Const MQRCCF_CHAD_EXIT_WRONG_TYPE As Short = 4084
	Public Const MQRCCF_SUPPRESSED_BY_EXIT As Short = 4085
	Public Const MQRCCF_BATCH_INT_ERROR As Short = 4086
	Public Const MQRCCF_BATCH_INT_WRONG_TYPE As Short = 4087
	Public Const MQRCCF_NET_PRIORITY_ERROR As Short = 4088
	Public Const MQRCCF_NET_PRIORITY_WRONG_TYPE As Short = 4089
	Public Const MQRCCF_CHANNEL_CLOSED As Short = 4090
	
	
	'**********************************************************************'
	'*  Values Related to MQCFIL Structure                                *'
	'**********************************************************************'
	
	'Structure Length (Fixed Part)'
	Public Const MQCFIL_STRUC_LENGTH_FIXED As Short = 16
	
	
	'**********************************************************************'
	'*  Values Related to MQCFIN Structure                                *'
	'**********************************************************************'
	
	'Structure Length'
	Public Const MQCFIN_STRUC_LENGTH As Short = 16
	
	
	'**********************************************************************'
	'*  Values Related to MQCFSL Structure                                *'
	'**********************************************************************'
	
	'Structure Length (Fixed Part)'
	Public Const MQCFSL_STRUC_LENGTH_FIXED As Short = 24
	
	
	'**********************************************************************'
	'*  Values Related to MQCFST Structure                                *'
	'**********************************************************************'
	
	'Structure Length (Fixed Part)'
	Public Const MQCFST_STRUC_LENGTH_FIXED As Short = 20
	
	
	'**********************************************************************'
	'*  Values Related to All Structures                                  *'
	'**********************************************************************'
	
	'Structure Type'
	Public Const MQCFT_COMMAND As Short = 1
	Public Const MQCFT_RESPONSE As Short = 2
	Public Const MQCFT_INTEGER As Short = 3
	Public Const MQCFT_STRING As Short = 4
	Public Const MQCFT_INTEGER_LIST As Short = 5
	Public Const MQCFT_STRING_LIST As Short = 6
	Public Const MQCFT_EVENT As Short = 7
	Public Const MQCFT_USER As Short = 8
	
	
	'**********************************************************************'
	'*  Values Related to Integer Parameter Structures                    *'
	'**********************************************************************'
	
	'Integer Parameter Types'
	Public Const MQIACF_FIRST As Short = 1001
	Public Const MQIACF_Q_MGR_ATTRS As Short = 1001
	Public Const MQIACF_Q_ATTRS As Short = 1002
	Public Const MQIACF_PROCESS_ATTRS As Short = 1003
	Public Const MQIACF_NAMELIST_ATTRS As Short = 1004
	Public Const MQIACF_FORCE As Short = 1005
	Public Const MQIACF_REPLACE As Short = 1006
	Public Const MQIACF_PURGE As Short = 1007
	Public Const MQIACF_QUIESCE As Short = 1008
	Public Const MQIACF_ALL As Short = 1009
	Public Const MQIACF_PARAMETER_ID As Short = 1012
	Public Const MQIACF_ERROR_ID As Short = 1013
	Public Const MQIACF_ERROR_IDENTIFIER As Short = 1013
	Public Const MQIACF_SELECTOR As Short = 1014
	Public Const MQIACF_CHANNEL_ATTRS As Short = 1015
	Public Const MQIACF_ESCAPE_TYPE As Short = 1017
	Public Const MQIACF_ERROR_OFFSET As Short = 1018
	Public Const MQIACF_REASON_QUALIFIER As Short = 1020
	Public Const MQIACF_COMMAND As Short = 1021
	Public Const MQIACF_OPEN_OPTIONS As Short = 1022
	Public Const MQIACF_AUX_ERROR_DATA_INT_1 As Short = 1070
	Public Const MQIACF_AUX_ERROR_DATA_INT_2 As Short = 1071
	Public Const MQIACF_CONV_REASON_CODE As Short = 1072
	Public Const MQIACF_BRIDGE_TYPE As Short = 1073
	Public Const MQIACF_INQUIRY As Short = 1074
	Public Const MQIACF_WAIT_INTERVAL As Short = 1075
	Public Const MQIACF_OPTIONS As Short = 1076
	Public Const MQIACF_BROKER_OPTIONS As Short = 1077
	Public Const MQIACF_SEQUENCE_NUMBER As Short = 1079
	Public Const MQIACF_INTEGER_DATA As Short = 1080
	Public Const MQIACF_REGISTRATION_OPTIONS As Short = 1081
	Public Const MQIACF_PUBLICATION_OPTIONS As Short = 1082
	Public Const MQIACF_CLUSTER_INFO As Short = 1083
	Public Const MQIACF_Q_MGR_DEFINITION_TYPE As Short = 1084
	Public Const MQIACF_Q_MGR_TYPE As Short = 1085
	Public Const MQIACF_ACTION As Short = 1086
	Public Const MQIACF_SUSPEND As Short = 1087
	Public Const MQIACF_BROKER_COUNT As Short = 1088
	Public Const MQIACF_APPL_COUNT As Short = 1089
	Public Const MQIACF_ANONYMOUS_COUNT As Short = 1090
	Public Const MQIACF_REG_REG_OPTIONS As Short = 1091
	Public Const MQIACF_DELETE_OPTIONS As Short = 1092
	Public Const MQIACF_CLUSTER_Q_MGR_ATTRS As Short = 1093
	Public Const MQIACF_LAST_USED As Short = 1093
	
	Public Const MQIACH_FIRST As Short = 1501
	Public Const MQIACH_XMIT_PROTOCOL_TYPE As Short = 1501
	Public Const MQIACH_BATCH_SIZE As Short = 1502
	Public Const MQIACH_DISC_INTERVAL As Short = 1503
	Public Const MQIACH_SHORT_TIMER As Short = 1504
	Public Const MQIACH_SHORT_RETRY As Short = 1505
	Public Const MQIACH_LONG_TIMER As Short = 1506
	Public Const MQIACH_LONG_RETRY As Short = 1507
	Public Const MQIACH_PUT_AUTHORITY As Short = 1508
	Public Const MQIACH_SEQUENCE_NUMBER_WRAP As Short = 1509
	Public Const MQIACH_MAX_MSG_LENGTH As Short = 1510
	Public Const MQIACH_CHANNEL_TYPE As Short = 1511
	Public Const MQIACH_DATA_COUNT As Short = 1512
	Public Const MQIACH_MSG_SEQUENCE_NUMBER As Short = 1514
	Public Const MQIACH_DATA_CONVERSION As Short = 1515
	Public Const MQIACH_IN_DOUBT As Short = 1516
	Public Const MQIACH_MCA_TYPE As Short = 1517
	Public Const MQIACH_CHANNEL_INSTANCE_TYPE As Short = 1523
	Public Const MQIACH_CHANNEL_INSTANCE_ATTRS As Short = 1524
	Public Const MQIACH_CHANNEL_ERROR_DATA As Short = 1525
	Public Const MQIACH_CHANNEL_TABLE As Short = 1526
	Public Const MQIACH_CHANNEL_STATUS As Short = 1527
	Public Const MQIACH_INDOUBT_STATUS As Short = 1528
	Public Const MQIACH_LAST_SEQ_NUMBER As Short = 1529
	Public Const MQIACH_LAST_SEQUENCE_NUMBER As Short = 1529
	Public Const MQIACH_CURRENT_MSGS As Short = 1531
	Public Const MQIACH_CURRENT_SEQ_NUMBER As Short = 1532
	Public Const MQIACH_CURRENT_SEQUENCE_NUMBER As Short = 1532
	Public Const MQIACH_MSGS As Short = 1534
	Public Const MQIACH_BYTES_SENT As Short = 1535
	Public Const MQIACH_BYTES_RCVD As Short = 1536
	Public Const MQIACH_BYTES_RECEIVED As Short = 1536
	Public Const MQIACH_BATCHES As Short = 1537
	Public Const MQIACH_BUFFERS_SENT As Short = 1538
	Public Const MQIACH_BUFFERS_RCVD As Short = 1539
	Public Const MQIACH_BUFFERS_RECEIVED As Short = 1539
	Public Const MQIACH_LONG_RETRIES_LEFT As Short = 1540
	Public Const MQIACH_SHORT_RETRIES_LEFT As Short = 1541
	Public Const MQIACH_MCA_STATUS As Short = 1542
	Public Const MQIACH_STOP_REQUESTED As Short = 1543
	Public Const MQIACH_MR_COUNT As Short = 1544
	Public Const MQIACH_MR_INTERVAL As Short = 1545
	Public Const MQIACH_NPM_SPEED As Short = 1562
	Public Const MQIACH_HB_INTERVAL As Short = 1563
	Public Const MQIACH_BATCH_INTERVAL As Short = 1564
	Public Const MQIACH_NETWORK_PRIORITY As Short = 1565
	Public Const MQIACH_LAST_USED As Short = 1565
	
	
	'**********************************************************************'
	'*  Values Related to Character Parameter Structures                  *'
	'**********************************************************************'
	
	'Character Parameter Types'
	Public Const MQCACF_FIRST As Short = 3001
	Public Const MQCACF_FROM_Q_NAME As Short = 3001
	Public Const MQCACF_TO_Q_NAME As Short = 3002
	Public Const MQCACF_FROM_PROCESS_NAME As Short = 3003
	Public Const MQCACF_TO_PROCESS_NAME As Short = 3004
	Public Const MQCACF_FROM_NAMELIST_NAME As Short = 3005
	Public Const MQCACF_TO_NAMELIST_NAME As Short = 3006
	Public Const MQCACF_FROM_CHANNEL_NAME As Short = 3007
	Public Const MQCACF_TO_CHANNEL_NAME As Short = 3008
	Public Const MQCACF_Q_NAMES As Short = 3011
	Public Const MQCACF_PROCESS_NAMES As Short = 3012
	Public Const MQCACF_NAMELIST_NAMES As Short = 3013
	Public Const MQCACF_ESCAPE_TEXT As Short = 3014
	Public Const MQCACF_LOCAL_Q_NAMES As Short = 3015
	Public Const MQCACF_MODEL_Q_NAMES As Short = 3016
	Public Const MQCACF_ALIAS_Q_NAMES As Short = 3017
	Public Const MQCACF_REMOTE_Q_NAMES As Short = 3018
	Public Const MQCACF_SENDER_CHANNEL_NAMES As Short = 3019
	Public Const MQCACF_SERVER_CHANNEL_NAMES As Short = 3020
	Public Const MQCACF_REQUESTER_CHANNEL_NAMES As Short = 3021
	Public Const MQCACF_RECEIVER_CHANNEL_NAMES As Short = 3022
	Public Const MQCACF_OBJECT_Q_MGR_NAME As Short = 3023
	Public Const MQCACF_APPL_NAME As Short = 3024
	Public Const MQCACF_USER_IDENTIFIER As Short = 3025
	Public Const MQCACF_AUX_ERROR_DATA_STR_1 As Short = 3026
	Public Const MQCACF_AUX_ERROR_DATA_STR_2 As Short = 3027
	Public Const MQCACF_AUX_ERROR_DATA_STR_3 As Short = 3028
	Public Const MQCACF_BRIDGE_NAME As Short = 3029
	Public Const MQCACF_STREAM_NAME As Short = 3030
	Public Const MQCACF_TOPIC As Short = 3031
	Public Const MQCACF_PARENT_Q_MGR_NAME As Short = 3032
	Public Const MQCACF_PUBLISH_TIMESTAMP As Short = 3034
	Public Const MQCACF_STRING_DATA As Short = 3035
	Public Const MQCACF_SUPPORTED_STREAM_NAME As Short = 3036
	Public Const MQCACF_REG_TOPIC As Short = 3037
	Public Const MQCACF_REG_TIME As Short = 3038
	Public Const MQCACF_REG_USER_ID As Short = 3039
	Public Const MQCACF_CHILD_Q_MGR_NAME As Short = 3040
	Public Const MQCACF_REG_STREAM_NAME As Short = 3041
	Public Const MQCACF_REG_Q_MGR_NAME As Short = 3042
	Public Const MQCACF_REG_Q_NAME As Short = 3043
	Public Const MQCACF_REG_CORREL_ID As Short = 3044
	Public Const MQCACF_LAST_USED As Short = 3044
	
	Public Const MQCACH_FIRST As Short = 3501
	Public Const MQCACH_CHANNEL_NAME As Short = 3501
	Public Const MQCACH_DESC As Short = 3502
	Public Const MQCACH_MODE_NAME As Short = 3503
	Public Const MQCACH_TP_NAME As Short = 3504
	Public Const MQCACH_XMIT_Q_NAME As Short = 3505
	Public Const MQCACH_CONNECTION_NAME As Short = 3506
	Public Const MQCACH_MCA_NAME As Short = 3507
	Public Const MQCACH_SEC_EXIT_NAME As Short = 3508
	Public Const MQCACH_MSG_EXIT_NAME As Short = 3509
	Public Const MQCACH_SEND_EXIT_NAME As Short = 3510
	Public Const MQCACH_RCV_EXIT_NAME As Short = 3511
	Public Const MQCACH_CHANNEL_NAMES As Short = 3512
	Public Const MQCACH_SEC_EXIT_USER_DATA As Short = 3513
	Public Const MQCACH_MSG_EXIT_USER_DATA As Short = 3514
	Public Const MQCACH_SEND_EXIT_USER_DATA As Short = 3515
	Public Const MQCACH_RCV_EXIT_USER_DATA As Short = 3516
	Public Const MQCACH_USER_ID As Short = 3517
	Public Const MQCACH_PASSWORD As Short = 3518
	Public Const MQCACH_LAST_MSG_TIME As Short = 3524
	Public Const MQCACH_LAST_MSG_DATE As Short = 3525
	Public Const MQCACH_MCA_USER_ID As Short = 3527
	Public Const MQCACH_CHANNEL_START_TIME As Short = 3528
	Public Const MQCACH_CHANNEL_START_DATE As Short = 3529
	Public Const MQCACH_MCA_JOB_NAME As Short = 3530
	Public Const MQCACH_LAST_LUWID As Short = 3531
	Public Const MQCACH_CURRENT_LUWID As Short = 3532
	Public Const MQCACH_FORMAT_NAME As Short = 3533
	Public Const MQCACH_MR_EXIT_NAME As Short = 3534
	Public Const MQCACH_MR_EXIT_USER_DATA As Short = 3535
	Public Const MQCACH_LAST_USED As Short = 3535
	
	
	'**********************************************************************'
	'*  Parameter Values                                                  *'
	'**********************************************************************'
	
	'Action Option'
	Public Const MQACT_FORCE_REMOVE As Short = 1
	
	'Bridge Type'
	Public Const MQBT_OTMA As Short = 1
	
	'Indoubt Status'
	Public Const MQCHIDS_NOT_INDOUBT As Short = 0
	Public Const MQCHIDS_INDOUBT As Short = 1
	
	'Channel Status'
	Public Const MQCHS_INACTIVE As Short = 0
	Public Const MQCHS_BINDING As Short = 1
	Public Const MQCHS_STARTING As Short = 2
	Public Const MQCHS_RUNNING As Short = 3
	Public Const MQCHS_STOPPING As Short = 4
	Public Const MQCHS_RETRYING As Short = 5
	Public Const MQCHS_STOPPED As Short = 6
	Public Const MQCHS_REQUESTING As Short = 7
	Public Const MQCHS_PAUSED As Short = 8
	Public Const MQCHS_INITIALIZING As Short = 13
	
	'Channel Stop Option'
	Public Const MQCHSR_STOP_NOT_REQUESTED As Short = 0
	Public Const MQCHSR_STOP_REQUESTED As Short = 1
	
	'Channel Table Type'
	Public Const MQCHTAB_Q_MGR As Short = 1
	Public Const MQCHTAB_CLNTCONN As Short = 2
	
	'Escape Type'
	Public Const MQET_MQSC As Short = 1
	
	'Event Recording'
	Public Const MQEVR_DISABLED As Short = 0
	Public Const MQEVR_ENABLED As Short = 1
	
	'Force Control'
	Public Const MQFC_YES As Short = 1
	Public Const MQFC_NO As Short = 0
	
	'Indoubt Option'
	Public Const MQIDO_COMMIT As Short = 1
	Public Const MQIDO_BACKOUT As Short = 2
	
	'Message Channel Agent Status'
	Public Const MQMCAS_STOPPED As Short = 0
	Public Const MQMCAS_RUNNING As Short = 3
	
	'Purge Option'
	Public Const MQPO_YES As Short = 1
	Public Const MQPO_NO As Short = 0
	
	'Queue Manager Definition Type'
	Public Const MQQMDT_EXPLICIT_CLUSTER_SENDER As Short = 1
	Public Const MQQMDT_AUTO_CLUSTER_SENDER As Short = 2
	Public Const MQQMDT_AUTO_EXP_CLUSTER_SENDER As Short = 4
	Public Const MQQMDT_CLUSTER_RECEIVER As Short = 3
	
	'Queue Manager Type'
	Public Const MQQMT_NORMAL As Short = 0
	Public Const MQQMT_REPOSITORY As Short = 1
	
	'Quiesce Option'
	Public Const MQQO_YES As Short = 1
	Public Const MQQO_NO As Short = 0
	
	'Queue Service-Interval Events'
	Public Const MQQSIE_NONE As Short = 0
	Public Const MQQSIE_HIGH As Short = 1
	Public Const MQQSIE_OK As Short = 2
	
	'Replace Option'
	Public Const MQRP_YES As Short = 1
	Public Const MQRP_NO As Short = 0
	
	'Reason Qualifiers'
	Public Const MQRQ_CONN_NOT_AUTHORIZED As Short = 1
	Public Const MQRQ_OPEN_NOT_AUTHORIZED As Short = 2
	Public Const MQRQ_CLOSE_NOT_AUTHORIZED As Short = 3
	Public Const MQRQ_CMD_NOT_AUTHORIZED As Short = 4
	Public Const MQRQ_Q_MGR_STOPPING As Short = 5
	Public Const MQRQ_Q_MGR_QUIESCING As Short = 6
	Public Const MQRQ_CHANNEL_STOPPED_OK As Short = 7
	Public Const MQRQ_CHANNEL_STOPPED_ERROR As Short = 8
	Public Const MQRQ_CHANNEL_STOPPED_RETRY As Short = 9
	Public Const MQRQ_CHANNEL_STOPPED_DISABLED As Short = 10
	Public Const MQRQ_BRIDGE_STOPPED_OK As Short = 11
	Public Const MQRQ_BRIDGE_STOPPED_ERROR As Short = 12
	
	'Queue Definition Scope'
	Public Const MQSCO_Q_MGR As Short = 1
	Public Const MQSCO_CELL As Short = 2
	
	'Suspend Status'
	Public Const MQSUS_YES As Short = 1
	Public Const MQSUS_NO As Short = 0
	
	
	'**********************************************************************'
	'*  Values Related to Publish/Subscribe                               *'
	'**********************************************************************'
	
	'Delete Options'
	Public Const MQDELO_NONE As Short = 0
	Public Const MQDELO_LOCAL As Short = 4
	
	'Publication Options'
	Public Const MQPUBO_NONE As Short = 0
	Public Const MQPUBO_CORREL_ID_AS_IDENTITY As Short = 1
	Public Const MQPUBO_RETAIN_PUBLICATION As Short = 2
	Public Const MQPUBO_OTHER_SUBSCRIBERS_ONLY As Short = 4
	Public Const MQPUBO_NO_REGISTRATION As Short = 8
	Public Const MQPUBO_IS_RETAINED_PUBLICATION As Short = 16
	
	'Registration Options'
	Public Const MQREGO_NONE As Short = 0
	Public Const MQREGO_CORREL_ID_AS_IDENTITY As Short = 1
	Public Const MQREGO_ANONYMOUS As Short = 2
	Public Const MQREGO_LOCAL As Short = 4
	Public Const MQREGO_DIRECT_REQUESTS As Short = 8
	Public Const MQREGO_NEW_PUBLICATIONS_ONLY As Short = 16
	Public Const MQREGO_PUBLISH_ON_REQUEST_ONLY As Short = 32
	Public Const MQREGO_DEREGISTER_ALL As Short = 64
	Public Const MQREGO_INCLUDE_STREAM_NAME As Short = 128
	Public Const MQREGO_INFORM_IF_RETAINED As Short = 256
	
	'User Attribute Selectors'
	Public Const MQUA_FIRST As Integer = 65536
	Public Const MQUA_LAST As Integer = 999999999
	
	
	'**********************************************************************'
	'*  MQCFH Structure -- PCF Header                                     *'
	'**********************************************************************'
	
	Structure MQCFH
		Dim Type As Integer 'Structure type'
		Dim StrucLength As Integer 'Structure length'
		Dim Version As Integer 'Structure version number'
		'UPGRADE_NOTE: Command was upgraded to Command_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
		Dim Command_Renamed As Integer 'Command identifier'
		Dim MsgSeqNumber As Integer 'Message sequence number'
		Dim Control As Integer 'Control options'
		Dim CompCode As Integer 'Completion code'
		Dim Reason As Integer 'Reason code qualifying completion code'
		Dim ParameterCount As Integer 'Count of parameter structures'
	End Structure
	
	'Default Instance of MQCFH Structure'
	Public MQCFH_DEFAULT As MQCFH
	
	
	'**********************************************************************'
	'*  MQCFIL Structure -- PCF Integer-List Parameter                    *'
	'**********************************************************************'
	
	Structure MQCFIL
		Dim Type As Integer 'Structure type'
		Dim StrucLength As Integer 'Structure length'
		Dim Parameter As Integer 'Parameter identifier'
		Dim Count As Integer 'Count of parameter values'
	End Structure
	
	'Default Instance of MQCFIL Structure'
	Public MQCFIL_DEFAULT As MQCFIL
	
	
	'**********************************************************************'
	'*  MQCFIN Structure -- PCF Integer Parameter                         *'
	'**********************************************************************'
	
	Structure MQCFIN
		Dim Type As Integer 'Structure type'
		Dim StrucLength As Integer 'Structure length'
		Dim Parameter As Integer 'Parameter identifier'
		Dim Value As Integer 'Parameter value'
	End Structure
	
	'Default Instance of MQCFIN Structure'
	Public MQCFIN_DEFAULT As MQCFIN
	
	
	'**********************************************************************'
	'*  MQCFSL Structure -- PCF String-List Parameter                     *'
	'**********************************************************************'
	
	Structure MQCFSL
		Dim Type As Integer 'Structure type'
		Dim StrucLength As Integer 'Structure length'
		Dim Parameter As Integer 'Parameter identifier'
		Dim CodedCharSetId As Integer 'Coded character set identifier'
		Dim Count As Integer 'Count of parameter values'
		Dim StringLength As Integer 'Length of one string'
	End Structure
	
	'Default Instance of MQCFSL Structure'
	Public MQCFSL_DEFAULT As MQCFSL
	
	
	'**********************************************************************'
	'*  MQCFST Structure -- PCF String Parameter                          *'
	'**********************************************************************'
	
	Structure MQCFST
		Dim Type As Integer 'Structure type'
		Dim StrucLength As Integer 'Structure length'
		Dim Parameter As Integer 'Parameter identifier'
		Dim CodedCharSetId As Integer 'Coded character set identifier'
		Dim StringLength As Integer 'Length of string'
	End Structure
	
	'Default Instance of MQCFST Structure'
	Public MQCFST_DEFAULT As MQCFST
	
	
	'**********************************************************************'
	'*  Subroutines to Set Structures to Default Values                   *'
	'**********************************************************************'
	
	Sub MQCFH_DEFAULTS(ByRef Struc As MQCFH)
		Struc.Type = MQCFT_COMMAND
		Struc.StrucLength = MQCFH_STRUC_LENGTH
		Struc.Version = MQCFH_VERSION_1
		Struc.Command_Renamed = MQCMD_NONE
		Struc.MsgSeqNumber = 1
		Struc.Control = MQCFC_LAST
		Struc.CompCode = MQCC_OK
		Struc.Reason = MQRC_NONE
		Struc.ParameterCount = 0
	End Sub
	
	Sub MQCFIL_DEFAULTS(ByRef Struc As MQCFIL)
		Struc.Type = MQCFT_INTEGER_LIST
		Struc.StrucLength = MQCFIL_STRUC_LENGTH_FIXED
		Struc.Parameter = 0
		Struc.Count = 0
	End Sub
	
	Sub MQCFIN_DEFAULTS(ByRef Struc As MQCFIN)
		Struc.Type = MQCFT_INTEGER
		Struc.StrucLength = MQCFIN_STRUC_LENGTH
		Struc.Parameter = 0
		Struc.Value = 0
	End Sub
	
	Sub MQCFSL_DEFAULTS(ByRef Struc As MQCFSL)
		Struc.Type = MQCFT_STRING_LIST
		Struc.StrucLength = MQCFSL_STRUC_LENGTH_FIXED
		Struc.Parameter = 0
		Struc.CodedCharSetId = MQCCSI_DEFAULT
		Struc.Count = 0
		Struc.StringLength = 0
	End Sub
	
	Sub MQCFST_DEFAULTS(ByRef Struc As MQCFST)
		Struc.Type = MQCFT_STRING
		Struc.StrucLength = MQCFST_STRUC_LENGTH_FIXED
		Struc.Parameter = 0
		Struc.CodedCharSetId = MQCCSI_DEFAULT
		Struc.StringLength = 0
	End Sub
	
	
	'**********************************************************************'
	'*  MQCF_DEFAULTS Subroutine -- Set Defaults                          *'
	'**********************************************************************'
	
	Sub MQCF_DEFAULTS()
		'Set default structures'
		MQCFH_DEFAULTS(MQCFH_DEFAULT)
		MQCFIL_DEFAULTS(MQCFIL_DEFAULT)
		MQCFIN_DEFAULTS(MQCFIN_DEFAULT)
		MQCFSL_DEFAULTS(MQCFSL_DEFAULT)
		MQCFST_DEFAULTS(MQCFST_DEFAULT)
	End Sub
	
	
	'**********************************************************************'
	'*  End of CMQB                                                       *'
	'**********************************************************************'
End Module